/** \file *********************************************************************
 *
 * gxerror02 - GX sample program
 *
 * 2006-2021 (c) Adaptive Recognition (https://adaptiverecognition.com)
 ******************************************************************************/

/**
 * Clear error example.
 *
 * Purpose:
 *		Shows the way of clearing the error message buffer.
 */

#include "gxsd.h"
#include "gxerror.h"
#include "gxsdldr.c"

/**
 * Main function
 */
int main(void) {
	int err_code;
	char err_str[256];
	err_str[sizeof(err_str)-1] = 0;

	/* Clears the error buffer */
	gx_clearerror();

	/* Gets the error code and description text */
	gx_geterrora(&err_code, err_str, sizeof(err_str)-1);

	/* Displays the error code and description text to STDOUT */
	printf("1. Error code: %i, Description: '%s'\n", err_code, err_str);

	/* Sets a new error code and description text */
	gx_seterror(GX_EINVAL, (const wchar_t *)L"%hs", "(Error occurred in my test application)");

	/* Gets second error code and description text */
	gx_geterrora(&err_code, err_str, sizeof(err_str)-1);

	/* Displays second error code and description text to STDOUT */
	printf("2. Error code: %i, Description: '%s'\n", err_code, err_str);

	return 0;
}
