// ******************************************************************************
// * GX error file - v7.3.1
// * 2004-2021 (c) Adaptive Recognition (https://adaptiverecognition.com)
// ******************************************************************************
// GX system error codes and messages </b>
// The GX is the base system for the majority of the Adaptive Recognition products.
// It is a collection of loadable modules and library functions and gives an easy
// to program interface to the hardware devices.
// This file contains the error codes and descriptions of the GX system.
// ******************************************************************************

unit gxerror;

interface
const
	// System and GX-specific error codes.
	GX_ENOERR			= $0000; // No Error

	GX_ENOENT			= $0002; // Entry not found (ENOENT)
	GX_ENOMEM			= $000c; // Memory allocation error (ENOMEM)
	GX_EACCES			= $000d; // Permission denied (EACCES)
	GX_EFAULT			= $000e; // Bad address or program error (EFAULT)
	GX_EBUSY			= $0010; // Resource busy (EBUSY)
	GX_EEXIST			= $0011; // File exists (EEXIST)
	GX_ENODEV			= $0013; // No such device (ENODEV)
	GX_EINVAL			= $0016; // Invalid parameter (EINVAL)
	GX_ERANGE			= $0022; // Data out of range (ERANGE)
	GX_EDATA			= $003D; // No data available (Linux - ENODATA)
	GX_ECOMM			= $0046; // Communication error on send (Linux - ECOMM)
	GX_ETIMEDOUT		= $006E; // Function timed out (Linux - ETIMEDOUT)

	// General error codes
	GX_EOPEN			= $1000; // File open error
	GX_ECREAT			= $1001; // File creation error
	GX_EREAD			= $1002; // File read error
	GX_EWRITE			= $1003; // File write error
	GX_EFILE			= $1004; // Invalid file content

	GX_EINVIMG			= $1010; // Invalid image
	GX_EINVFUNC			= $1011; // Invalid function

	GX_EHWKEY			= $1012; // Hardware key does not work properly (Local NNC)
	GX_EVERSION			= $1013; // Invalid version
	GX_EASSERT			= $1014; // Assertion occurred

	GX_EDISCON			= $1015; // Device is disconnected

	GX_EIMGPROC			= $1016; // Image processing failed

	GX_EAUTH			= $1017; // Authenticity cannot be determined
	GX_ELIC				= $1018; // Licence handling error
	GX_ELICDENIED		= $1019; // Licence is denied

	GX_ENNCLIMIT		= $1030; // Limit of the licence reached: no further OCR process can be done
	GX_ENNCNLO			= $1031; // NNC device is no longer operational
	GX_ECMLICNUM		= $1032; // Only one CARMEN license can be uploaded

	GX_EHWKEYIP			= $1040; // Hardware key does not work properly (IP NNC)
	GX_EHWKEYIPNET		= $1041; // IP NNC network error

	// Module error codes
	// GX_xxx = 0xmmmm8xxx		 // mmmm => group code

	GX_ENOMODULE		= $8000; // The specified module not found (module: '%ls')
implementation
end.
