Attribute VB_Name = "fpstypes"
'-------------------------------------------------------------------------------
' FPS TYPES 2010-2021 (c) Adaptive Recognition
' 2021.06.03 v2.1.10
'-------------------------------------------------------------------------------

'Device connection modes
' FPS_USAGEMODE
Public Const FPS_UMODE_DISCONNECT = 0
Public Const FPS_UMODE_NORMAL_USE = 1
Public Const FPS_UMODE_FULL_CONTROL = 2

'Device freerun light controlling modes
' FPS_FREERUNMODE
Public Const FPS_FRMODE_NULL = &H0
Public Const FPS_FRMODE_PREVIEWLIGHT = &H1
Public Const FPS_FRMODE_TESTPRESENCE = &H4
Public Const FPS_FRMODE_HQPREVIEW = &H10
Public Const FPS_FRMODE_ROLLPREVIEW = &H20

'Finger presence detection modes
' FPS_TESTPRESENCE
Public Const FPS_TP_ABSENT = 0
Public Const FPS_TP_DEFAULT = 2
Public Const FPS_TP_DIRTY = 3
Public Const FPS_TP_PRESENT = 4

'Image types
' FPS_IMAGE_TYPE
Public Const FPS_IT_PREVIEW = 2
Public Const FPS_IT_FINGER = 3

'Event types
' FPS_EVENT
Public Const FPS_ET_CAPTURE = 2

Public Const FPS_EV_CAPTUREFINISHED = 101
Public Const FPS_EV_IMAGECAPTURED = 102
Public Const FPS_EV_FGCAP = 106
Public Const FPS_EV_PREVIEWCAPTURED = 107

'Power state codes
' FPS_POWER_STATE
Public Const FPS_PWR_MASK = &HF

Public Const FPS_PWR_UNKNOWN = &H0
Public Const FPS_PWR_OFF = &H1
Public Const FPS_PWR_ON = &H2

Public Const FPS_BATTERY_MASK = &HF0

Public Const FPS_BATTERY_UNAVAILABLE = &H0
Public Const FPS_BATTERY_AVAILABLE = &H10
Public Const FPS_BATTERY_UNKNOWN = &H20

'Status led color codes
' FPS_STATUS_LED_COLOR
Public Const FPS_SLC_OFF = &H0
Public Const FPS_SLC_GREEN = &H81
Public Const FPS_SLC_RED = &H82
Public Const FPS_SLC_ORANGE = &H83
Public Const FPS_SLC_BLUE = &H84
Public Const FPS_SLC_AUTO = &HAC
Public Const FPS_SLC_ANY = &HFF

'Id of the buzzer
' FPS_BUZZER
Public Const FPS_SLC_BUZZER = &HC0

'Button state codes
' FPS_KEY_STATE
Public Const FPS_KEY_UNKNOWN = 0
Public Const FPS_KEY_PRESSED = 1
Public Const FPS_KEY_RELEASED = 2
Public Const FPS_KEY_NOKEY = 3

'Button codes
' FPS_KEY_CODE
Public Const FPS_KEY_POWER = &H10101
Public Const FPS_KEY_START = &H10110

'Variant IDs used
' FPS_VAR_ID

Public Const FPSV_ROOT = 0

Public Const FPSV_PAGELIST = FPSV_ROOT Or 1

Public Const FPSV_CONFIDENCE = &HD0000005

Public Const FPSV_IMAGE = &HD0100000
Public Const FPSV_IMAGELIST = FPSV_IMAGE Or 1
Public Const FPSV_IMAGEFRAME = FPSV_IMAGE Or 2

Public Const FPSV_DEVICE_INFO = &HD0200000
Public Const FPSV_DEVICE_ID = FPSV_DEVICE_INFO Or 1
Public Const FPSV_CAPTIME = FPSV_DEVICE_INFO Or 3

Public Const FPSV_COMMON = &HD0700000
Public Const FPSV_PROCTIME = FPSV_COMMON Or 1
Public Const FPSV_PROCPERIOD = FPSV_COMMON Or 2
Public Const FPSV_WARNLIST = FPSV_COMMON Or 3
Public Const FPSV_TASK = FPSV_COMMON Or 4

Public Const FPSV_FINGER = &HD0800000
Public Const FPSV_FINGER_TYPE = FPSV_FINGER Or 1
Public Const FPSV_NIST_QUALITY = FPSV_FINGER Or 2
Public Const FPSV_DRYWET = FPSV_FINGER Or 3
Public Const FPSV_FRACTION = FPSV_FINGER Or 4

'Finger storage IDs.
' FPS_POSITION
Public Const FPS_POS_UNKNOWN = 0
Public Const FPS_POS_RIGHT_THUMB = 1
Public Const FPS_POS_RIGHT_INDEX = 2
Public Const FPS_POS_RIGHT_MIDDLE = 3
Public Const FPS_POS_RIGHT_RING = 4
Public Const FPS_POS_RIGHT_LITTLE = 5
Public Const FPS_POS_LEFT_THUMB = 6
Public Const FPS_POS_LEFT_INDEX = 7
Public Const FPS_POS_LEFT_MIDDLE = 8
Public Const FPS_POS_LEFT_RING = 9
Public Const FPS_POS_LEFT_LITTLE = 10

Public Const FPS_POS_PLAIN_RIGHT_THUMB = 11
Public Const FPS_POS_PLAIN_LEFT_THUMB = 12
Public Const FPS_POS_PLAIN_RIGHT_4FINGERS = 13
Public Const FPS_POS_PLAIN_LEFT_4FINGERS = 14
Public Const FPS_POS_PLAIN_THUMBS = 15

Public Const FPS_POS_BOTH_INDEXES = 46

'The target object of fingerprint scanning.
' FPS_SCAN_OBJECT
Public Const FPS_SCAN_LEFT_HAND = 1
Public Const FPS_SCAN_RIGHT_HAND = 2
Public Const FPS_SCAN_TWO_THUMBS = 3

'The capturing mode of the finger capture process.
' FPS_IMPRESSION_TYPE
Public Const FPS_SCAN_LIVE = 0
Public Const FPS_SCAN_ROLLED = 1
Public Const FPS_SCAN_ACCUMULATED = &H1000

'Finger existence IDs.
' FPS_PRESENCE
Public Const FPS_NO_INFO = 0
Public Const FPS_AMPUTATION = 1
Public Const FPS_NO_PRINT = 2
Public Const FPS_AVAILABLE = 3

' Warnings about finger capture.
' FPS_FAILURE
Public Const FPS_FAIL_LEFT = 1
Public Const FPS_FAIL_RIGHT = 2
Public Const FPS_FAIL_TOP = 4
Public Const FPS_FAIL_BOTTOM = 8
Public Const FPS_FAIL_MISSING = &H10
Public Const FPS_FAIL_EXTRA = &H20
Public Const FPS_FAIL_HAND = &H40
Public Const FPS_FAIL_UPRIGHT = &H80
