/** \file *********************************************************************
 *
 * gxerror01 - GX sample program
 *
 * 2006-2021 (c) Adaptive Recognition (https://adaptiverecognition.com)
 ******************************************************************************/

/**
 * Set, get error example
 *
 * Purpose:
 *		Shows the way of setting and reading the error message buffer.
 */

#include "gxsd.h"
#include "gxerror.h"
#include "gxsdldr.c"

/**
 * Main function
 */
int main(void) {
	int err_code;

	/* Unicode version */
	{
		wchar_t err_str[256];

		/* Updates the error buffer */
		gx_seterror(GX_EINVAL, L"(Test string [%i %hs %ls])", (int)1234, "ABC", L"ABC");

		/* Gets the error string and code */
		err_code = gx_geterror(0, err_str, sizeof(err_str)/sizeof(wchar_t)-1);

		err_str[sizeof(err_str)/sizeof(wchar_t)-1] = 0;
		printf("Error code: %i, Description: '%ls'\n", err_code, err_str);
	}

	/* ASCII version */
	{
		char err_str[256];

		/* Updates the error buffer */
		gx_seterrora(GX_EINVAL, "(Test string [%i %hs %ls])", (int)1234, "ABC", L"ABC");

		/* Gets the error string and code */
		err_code = gx_geterrora(0, err_str, sizeof(err_str)/sizeof(char)-1);

		err_str[sizeof(err_str)/sizeof(char)-1] = 0;
		printf("Error code: %i, Description: '%hs'\n", err_code, err_str);
	}

	return 0;
}
