unit USample2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, GXIMAGE_OCXLib_TLB, PRAPI_OCXLib_TLB, Menus,
  ExtCtrls, Gauges;

type
  TFSample2 = class(TForm)
	Label1: TLabel;
	lType: TLabel;
	lCode: TLabel;
	Label3: TLabel;
	lPassportNo: TLabel;
	Label5: TLabel;
	Label2: TLabel;
	lSurname: TLabel;
	Label4: TLabel;
	lGivenName: TLabel;
	Label6: TLabel;
	lNationality: TLabel;
	Label7: TLabel;
	lDateOfBirth: TLabel;
	Label8: TLabel;
	lSex: TLabel;
	Label9: TLabel;
	lDateOfIssue: TLabel;
	Label11: TLabel;
	lDateOfExpiry: TLabel;
	Label10: TLabel;
	lPersonalNumber: TLabel;
	Label13: TLabel;
	lPlaceOfBirth: TLabel;
	Label15: TLabel;
	lAuthority: TLabel;
	Label17: TLabel;
	prApi: TPrApiOCX;
	prDoc: TPrDocOCX;
	iHoldersSignature: TGxImageOCX;
	pDG9: TPanel;
	pDG10: TPanel;
	pDG11: TPanel;
	pDG12: TPanel;
	pDG13: TPanel;
	pDG14: TPanel;
	pDG15: TPanel;
	pDG16: TPanel;
	pDG1: TPanel;
	pDG2: TPanel;
	pDG3: TPanel;
	pDG4: TPanel;
	pDG5: TPanel;
	pDG6: TPanel;
	pDG7: TPanel;
	pDG8: TPanel;
	pActiveAuth: TPanel;
	pPassiveAuth: TPanel;
	gbHints: TGroupBox;
	Panel2: TPanel;
	Label12: TLabel;
	Panel1: TPanel;
	Label14: TLabel;
	Panel3: TPanel;
	Label16: TLabel;
	Panel4: TPanel;
	Label18: TLabel;
	Panel5: TPanel;
	Label19: TLabel;
	pBAC: TPanel;
	lMRZ: TLabel;
	Memo1: TMemo;
	pImg: TPanel;
	Img: TGxImageOCX;
	OpenDialog: TOpenDialog;
	MainMenu: TMainMenu;
	mFile: TMenuItem;
	mLoadCertificate: TMenuItem;
	mQuit: TMenuItem;
	mHelp: TMenuItem;
	mAbout: TMenuItem;
	pProcess: TPanel;
	lProcess: TLabel;
	pChipAuth: TPanel;
	pTerminalAuth: TPanel;
	N1: TMenuItem;
	pFinger1: TPanel;
	Finger1: TGxImageOCX;
	pFinger2: TPanel;
	Finger2: TGxImageOCX;
	Label20: TLabel;
	procedure prApiTestDocEvent(ASender: TObject; status: Integer);
	procedure FormCreate(Sender: TObject);
	procedure FormKeyDown(Sender: TObject; var Key: Word;
	  Shift: TShiftState);
	procedure prApiButtonEvent(ASender: TObject; keycode, event: Integer);
	procedure FormClose(Sender: TObject; var Action: TCloseAction);
	procedure mQuitClick(Sender: TObject);
	procedure mAboutClick(Sender: TObject);
	procedure mLoadCertificateClick(Sender: TObject);
  private
	{ Private declarations }
	_processing: Boolean;
	function GetErrorMsg(const api: TPrApiOCX): string; overload;
	procedure ShowError(const api: TPrApiOCX); overload;
	function GetErrorMsg(const doc: TPrDocOCX): string; overload;
	procedure ShowError(const doc: TPrDocOCX); overload;
  public
	{ Public declarations }
	procedure Clear;
	procedure Process;
	procedure SaveData(const filename: string; const data: OleVariant);
  end;

var
  FSample2: TFSample2;

implementation

{$R *.dfm}

uses prtypes, prdoctypes, gxerror;

function TFSample2.GetErrorMsg(const api: TPrApiOCX): string;
begin
	Result := 'Error' + ' (' + IntToHex(api.GetErrorCode, 8) + '): ' + api.GetErrorString;
end;

procedure TFSample2.ShowError(const api: TPrApiOCX);
begin
	lMRZ.Caption := GetErrorMsg(api);
end;

function TFSample2.GetErrorMsg(const doc: TPrDocOCX): string;
begin
	Result := 'Error' + ' (' + IntToHex(doc.GetErrorCode, 8) + '): ' + doc.GetErrorString;
end;

procedure TFSample2.ShowError(const doc: TPrDocOCX);
begin
	lMRZ.Caption := GetErrorMsg(doc);
end;

procedure TFSample2.FormCreate(Sender: TObject);
var
	lights: Integer;
begin
	if not prApi.UseDeviceN(0, PR_UMODE_FULL_CONTROL) then begin
		MessageDlg(GetErrorMsg(prApi), mtError, [mbOk], 0);
		Application.Terminate;
	end;

	prApi.SetStatusLed($03, PR_SLC_GREEN);
	prApi.FreerunMode := PR_FRMODE_TESTDOCUMENT;
	lights := prApi.GetLightMask(PR_LIGHT_INFRA,0);
	prApi.SetPageLight(1,lights);

	_processing := false;
	Clear;
	Img.Connect(prDoc.GetImageSource, prDoc.GetSourceHandle);
	Img.ImgSrcParam := IntToStr(PR_DF_RFID_FACE);
	Finger1.Connect(prDoc.GetImageSource, prDoc.GetSourceHandle);
	Finger1.ImgSrcParam := IntToStr(PR_DF_RFID_FINGERPRINT) + ',0';
	Finger2.Connect(prDoc.GetImageSource, prDoc.GetSourceHandle);
	Finger2.ImgSrcParam := IntToStr(PR_DF_RFID_FINGERPRINT) + ',1';
	iHoldersSignature.Connect(prDoc.GetImageSource, prDoc.GetSourceHandle);
	iHoldersSignature.ImgSrcParam := IntToStr(PR_DF_RFID_SIGNATURE);
end;

procedure TFSample2.Clear;
var i: Integer;
	p: TPanel;
begin
	Img.ClearImage;
	iHoldersSignature.ClearImage;
	Finger1.ClearImage;
	Finger2.ClearImage;

	lType.Caption := '';
	lCode.Caption := '';
	lPassportNo.Caption := '';
	lSurname.Caption := '';
	lGivenName.Caption := '';
	lNationality.Caption := '';
	lDateOfBirth.Caption := '';
	lSex.Caption := '';
	lDateOfIssue.Caption := '';
	lDateOfExpiry.Caption := '';
	lPersonalNumber.Caption := '';
	lPlaceOfBirth.Caption := '';
	lAuthority.Caption := '';
	lMRZ.Caption := '';

	pBAC.Font.Color := clGray;
	pBAC.Color := clWhite;
	for i := 1 to 16 do begin
		p := TPanel(FindComponent('pDG'+IntToStr(i)));
		p.Font.Color := clGray;
		p.Color := clWhite;
	end;
	pActiveAuth.Font.Color := clGray;
	pActiveAuth.Color := clWhite;
	pPassiveAuth.Font.Color := clGray;
	pPassiveAuth.Color := clWhite;
	pChipAuth.Font.Color := clGray;
	pChipAuth.Color := clWhite;
	pTerminalAuth.Font.Color := clGray;
	pTerminalAuth.Color := clWhite;

	prDoc.Document := 0;
end;

procedure TFSample2.prApiTestDocEvent(ASender: TObject; status: Integer);
begin
	if status = PR_TD_IN then Process;
end;

procedure TFSample2.prApiButtonEvent(ASender: TObject; keycode,
  event: Integer);
begin
	if _processing then Exit;
	if (event = PR_KEY_PRESSED) then
		if ((keycode = $0D) or (keycode = PR_KEY_START)) then Process;
end;

procedure TFSample2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if _processing then Exit;
	case Key of
		VK_ESCAPE: Close;
		VK_RETURN: Process;
		VK_F2: prApi.Suspend;
		VK_F3: prApi.WakeUp;
	end;
end;

procedure TFSample2.mAboutClick(Sender: TObject);
begin
	ShowMessage('This is a sample program for showing the functionality of the ' +
		'prApi and prDoc ActiveX controls on reading RFID data.');
end;

procedure TFSample2.mQuitClick(Sender: TObject);
begin
	if not _processing then Close;
end;

procedure TFSample2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	prApi.SetStatusLed($FF, PR_SLC_OFF);
	prApi.FreerunMode := PR_FRMODE_NULL;
end;

procedure TFSample2.Process;
var
	i: Integer;
	CardName: WideString;
	FileName: string;
	mrzlines: WideString;
	text: string;
	rfid_files: Cardinal;
	data: OleVariant;
	warning: Boolean;
begin
	if _processing then Exit;
	_processing := true;
	Screen.Cursor := crHourGlass;
	lProcess.Visible := true;
	prApi.SetStatusLed($03, PR_SLC_RED);
	prApi.FreerunMode := PR_FRMODE_NULL;

	Clear;
	Application.ProcessMessages;

	if (prApi.GetRfidCardList > 0) and prApi.GetRfidCard(0, CardName) and prApi.ConnectRfidCard(CardName) then begin
		lMRZ.Caption := 'Reading RFID data ...';
		Application.ProcessMessages;
		if not prApi.GetRfidFileB(CardName, PR_RFID_EF_COM, data) then begin
			ShowError(prApi);
			warning := prApi.GetErrorCode <> GX_EACCES;
			if warning then
				lMRZ.Caption := 'Trying BAC ...'
			else
				lMRZ.Caption := 'Making BAC ...';

			pBAC.Font.Color := clBlack;
			Application.ProcessMessages;

			prApi.Capture;
			prDoc.Document := prApi.GetMrz(0, PR_LIGHT_INFRA, PR_IT_ORIGINAL);
			mrzlines := prDoc.Field(PR_DF_MRZ1) + #13#10 + prDoc.Field(PR_DF_MRZ2) + #13#10 + prDoc.Field(PR_DF_MRZ3);

			if not prApi.MakeBAC(CardName, mrzlines) then begin
				ShowError(prApi);
				pBAC.Color := clRed;
				Application.ProcessMessages;
			end else begin
				if warning then
					pBAC.Color := clYellow
				else
					pBAC.Color := clLime;
				Application.ProcessMessages;

				if not prApi.GetRfidFileB(CardName, PR_RFID_EF_COM, data) then begin
					ShowError(prApi);
				end else begin
					prDoc.Document := prApi.ResolveRfidData(data);
				end;
			end;
		end else begin
			prDoc.Document := prApi.ResolveRfidData(data);
		end;

		if not prDoc.Valid or not prDoc.FieldProperty(PR_DF_RFID_FIELDS or PR_DFE_DOCUMENT_DESCRIPTOR, PR_PROP_TYPE_RFID_FILES, data) then begin
			ShowError(prDoc);
		end else begin
			rfid_files := data;

			if ((rfid_files and (1 shl PR_RFID_EF_DG14)) <> 0) then begin
				pChipAuth.Font.Color := clBlack;
				Application.ProcessMessages;
				if prApi.MakeChipAuth(CardName) then pChipAuth.Color := clLime
				else pChipAuth.Color := clRed;
				Application.ProcessMessages;
			end;

			pPassiveAuth.Font.Color := clBlack;
			Application.ProcessMessages;
			if prApi.MakePassiveAuth(CardName) then pPassiveAuth.Color := clLime
			else pPassiveAuth.Color := clRed;
			Application.ProcessMessages;

			if ((rfid_files and (1 shl PR_RFID_EF_DG15)) <> 0) then begin
				pActiveAuth.Font.Color := clBlack;
				Application.ProcessMessages;
				if prApi.MakeActiveAuth(CardName) then pActiveAuth.Color := clLime
				else pActiveAuth.Color := clRed;
				Application.ProcessMessages;
			end;

			if ((rfid_files and (1 shl PR_RFID_EF_DG14)) <> 0) then begin
				pTerminalAuth.Font.Color := clBlack;
				Application.ProcessMessages;
				if prApi.MakeTerminalAuth(CardName) then pTerminalAuth.Color := clLime
				else pTerminalAuth.Color := clRed;
				Application.ProcessMessages;
			end;

			for i := PR_RFID_EF_COM to PR_RFID_EF_SOD do begin
				if ((rfid_files and Cardinal(1 shl i)) = 0) then Continue;

				if (i >= PR_RFID_EF_DG1) and (i <= PR_RFID_EF_DG16) then begin
					TPanel(FindComponent('pDG' + IntToStr(i))).Font.Color := clBlack;
					Application.ProcessMessages;
				end;

				if i = PR_RFID_EF_COM then FileName := 'COM'
				else if i = PR_RFID_EF_CVCA then FileName := 'CVCA'
				else if (i >= PR_RFID_EF_DG1) and (i <= PR_RFID_EF_DG16) then FileName := 'DG' + IntToStr(i)
				else if i = PR_RFID_EF_SOD then FileName := 'SOD'
				else FileName := 'Unknown';

				if prApi.GetRfidFileB(CardName, i, data) then begin
					SaveData('EF_' + FileName + '.dat', data);

					prDoc.Document := prApi.ResolveRfidData(data);
					if prDoc.Valid then begin
						case i of
							PR_RFID_EF_DG1: begin
								text := prDoc.Field(PR_DF_RFID_MRZ);

								if Length(text) mod 3 = 0 then
									lMRZ.Caption := Copy(text, 1, Length(text) div 3) + #13#10 +
													Copy(text, Length(text) div 3 + 1, Length(text) div 3) + #13#10 +
													Copy(text, (Length(text) div 3) * 2 + 1, Length(text) div 3)
								else
									lMRZ.Caption := Copy(text, 1, Length(text) div 2) + #13#10 + Copy(text, Length(text) div 2 + 1, Length(text) div 2);

								mrzlines := text;
								prDoc.Document := prApi.ResolveMrzText(mrzlines);

								lType.Caption := prDoc.Field(PR_DF_TYPE);
								lCode.Caption := prDoc.Field(PR_DF_ISSUE_COUNTRY);
								lPassportNo.Caption := prDoc.Field(PR_DF_DOCUMENT_NUMBER);
								lSurname.Caption := prDoc.Field(PR_DF_SURNAME);
								lGivenName.Caption := prDoc.Field(PR_DF_GIVENNAME);
								lNationality.Caption := prDoc.Field(PR_DF_NATIONALITY);
								lDateOfBirth.Caption := prDoc.Field(PR_DF_BIRTH_DATE);
								lSex.Caption := prDoc.Field(PR_DF_SEX);
								lDateOfExpiry.Caption := prDoc.Field(PR_DF_EXPIRY_DATE);
								lPersonalNumber.Caption := prDoc.Field(PR_DF_PERSONAL_NUMBER);
							end;

							PR_RFID_EF_DG2: begin
								Img.UpdateImage;
							end;

							PR_RFID_EF_DG3: begin
								Finger1.UpdateImage;
								Finger2.UpdateImage;
							end;

							PR_RFID_EF_DG7: begin
								iHoldersSignature.UpdateImage;
							end;

							PR_RFID_EF_DG11: begin
								lDateOfBirth.Caption := prDoc.Field(PR_DF_RFID_FIELDS or PR_DFE_BIRTH_DATE);
								lPlaceOfBirth.Caption := prDoc.Field(PR_DF_RFID_FIELDS or PR_DFE_BIRTH_PLACE);
								if Length(prDoc.Field(PR_DF_RFID_FIELDS or PR_DFE_PERSONAL_NUMBER))<>0
									then lPersonalNumber.Caption := prDoc.Field(PR_DF_RFID_FIELDS or PR_DFE_PERSONAL_NUMBER);
							end;

							PR_RFID_EF_DG12: begin
								lAuthority.Caption := prDoc.Field(PR_DF_RFID_FIELDS or PR_DFE_ISSUE_ORG);
								lDateOfIssue.Caption := prDoc.Field(PR_DF_RFID_FIELDS or PR_DFE_ISSUE_DATE);
							end;
						end;
					end;

					if (i >= PR_RFID_EF_DG1) and (i <= PR_RFID_EF_DG16) then begin
						warning := not prapi.CheckRfidFileHash(CardName, i);
						if warning then
							TPanel(FindComponent('p' + FileName)).Color := clYellow
						else
							TPanel(FindComponent('p' + FileName)).Color := clLime;
						Application.ProcessMessages;
					end;

				end else begin
					if (i >= PR_RFID_EF_DG1) and (i <= PR_RFID_EF_DG16) then begin
						TPanel(FindComponent('p' + FileName)).Color := clRed;
						Application.ProcessMessages;
					end;
				end;
			end;

		end;
		prApi.DisconnectRfidCard(CardName);
	end else begin
		lMRZ.Caption := 'Reading MRZ data...';
		Application.ProcessMessages;
		prApi.Capture;
		prDoc.Document := prApi.GetMrz(0, PR_LIGHT_INFRA, PR_IT_ORIGINAL);
		if prDoc.Valid then begin
			if Length(prDoc.Field(PR_DF_MRZ3)) = 0 then
				lMRZ.Caption := prDoc.Field(PR_DF_MRZ1) + #13#10 + prDoc.Field(PR_DF_MRZ2)
			else
				lMRZ.Caption := prDoc.Field(PR_DF_MRZ1) + #13#10 + prDoc.Field(PR_DF_MRZ2) + #13#10 + prDoc.Field(PR_DF_MRZ3);

			lType.Caption := prDoc.Field(PR_DF_TYPE);
			lCode.Caption := prDoc.Field(PR_DF_ISSUE_COUNTRY);
			lPassportNo.Caption := prDoc.Field(PR_DF_DOCUMENT_NUMBER);
			lSurname.Caption := prDoc.Field(PR_DF_SURNAME);
			lGivenName.Caption := prDoc.Field(PR_DF_GIVENNAME);
			lNationality.Caption := prDoc.Field(PR_DF_NATIONALITY);
			lDateOfBirth.Caption := prDoc.Field(PR_DF_BIRTH_DATE);
			lSex.Caption := prDoc.Field(PR_DF_SEX);
			lDateOfExpiry.Caption := prDoc.Field(PR_DF_EXPIRY_DATE);
			lPersonalNumber.Caption := prDoc.Field(PR_DF_PERSONAL_NUMBER);
		end else begin
			lMRZ.Caption := '!!! NO MRZ DATA !!!';
		end;
	end;
	prApi.SetStatusLed($03, PR_SLC_GREEN);
	prApi.FreerunMode := PR_FRMODE_TESTDOCUMENT;
	lProcess.Visible := false;
	Screen.Cursor := crArrow;
	_processing := false;
end;

procedure TFSample2.SaveData(const filename: string; const data: OleVariant);
var
	p: PChar;
	LogFile: File;
begin
	AssignFile(LogFile, filename);
	Rewrite(LogFile, 1);
	p := VarArrayLock(data);
	BlockWrite(LogFile, p^, VarArrayHighBound(data, 1) - VarArrayLowBound(data, 1) + 1);
	VarArrayUnlock(data);
	CloseFile(LogFile);
end;

procedure TFSample2.mLoadCertificateClick(Sender: TObject);
var
	pk: string;
begin
	if OpenDialog.Execute then begin
		pk := '';
		if ExtractFileExt(OpenDialog.FileName) = '.cvcert' then
			pk := ChangeFileExt(OpenDialog.FileName, '.pkcs8');
		if (pk <> '') and (not FileExists(pk)) then pk := '';

		if prApi.LoadCertFile(OpenDialog.FileName, pk) then
			ShowMessage('Loading certificate file succeeded.')
		else
			ShowError(prApi);
	end;
end;

end.

