//------------------------------------------------------------------------------
unit prdoctypes;
//------------------------------------------------------------------------------
// PR Doctypes file - V2.1.10
//
// 2004-2021 (c) Adaptive Recognition (https://adaptiverecognition.com)
//------------------------------------------------------------------------------
interface
//------------------------------------------------------------------------------
const

//Status Values
{ PR_CHKERR }
	PR_CHKERR_OK				= 0;
	PR_CHKERR_NO_CHECKSUM		= 1;

	//warnings
	PR_CHKERR_WARNING			= 100;

	PR_CHKERR_DATA_INTEGRITY	= 101;
	PR_CHKERR_OCR_WARNING		= 102;

	//errors
	PR_CHKERR_ERROR				= 200;

	PR_CHKERR_ILLEGAL_CHAR		= 201;
	PR_CHKERR_ILLEGAL_CHECKSUM	= 202;
	PR_CHKERR_CHECKSUM			= 203;

//Document Code Values
{ PR_DOCUMENT }

	PR_DOC_UNKNOWN			= 0;

	PR_DOC_PASSPORT			= 1;
	PR_DOC_IDCARD			= 2;
	PR_DOC_IDCARD2			= 3;
	PR_DOC_VISA				= 4;
	PR_DOC_IDFRA			= 5;
	PR_DOC_IDCARDPRE		= 6;
	PR_DOC_IDSVK1B			= 7;
	PR_DOC_DLAAMVA			= 8;
	PR_DOC_IDBEL3B			= 9;
	PR_DOC_DLCHEB			= 10;
	PR_DOC_IDCIV			= 11;
	PR_DOC_FTCARD			= 12;
	PR_DOC_BPIATA			= 13;
	PR_DOC_IDCARDO2			= 14;
	PR_DOC_IDCARDO3			= 15;
	PR_DOC_IDLC				= 16;
	PR_DOC_MAIL				= 17;
	PR_DOC_EMRTD			= 18;
	PR_DOC_EID				= 19;
	PR_DOC_ESIGN			= 20;
	PR_DOC_NFC				= 21;
	PR_DOC_EDL				= 22;
	PR_DOC_IDPRT			= 23;
	PR_DOC_IDECU			= 24;
	PR_DOC_IDMRZ			= 25;
	PR_DOC_IDUSDOD			= 26;

	//hungarian module
	PR_DOC_ACHUN			= 101;
	PR_DOC_PNOCARD_HUN		= 102;
	PR_DOC_DLHUNF			= 103;
	PR_DOC_DLHUNB			= 104;
	PR_DOC_IDHUNF			= 105;
	PR_DOC_IDHUNB			= 106;
	PR_DOC_IDHUNO			= 107;
	PR_DOC_DLHEUF			= 108;
	PR_DOC_DLHEUB			= 109;
	PR_DOC_PPHUN			= 110;
	PR_DOC_E111HUNB			= 111;
	PR_DOC_HICHUNO			= 112;
	PR_DOC_E111HUNB2		= 113;
	PR_DOC_HICHUNO2			= 114;
	PR_DOC_HICHUNO3			= 115;
	PR_DOC_PPHUN1			= 116;
	PR_DOC_PNOCARD_HUN1		= 117;
	PR_DOC_PPHUN2			= 118;
	PR_DOC_IDHUN2F			= 119;
	PR_DOC_IDHUN2B			= 120;
	PR_DOC_PNOCARD_HUN2		= 121;
	PR_DOC_DLHUN2F			= 122;
	PR_DOC_DLHUN2B			= 123;

	//spanish module
	PR_DOC_IDESPF			= 201;
	PR_DOC_IDESPB			= 202;
	PR_DOC_IDESPBO			= 203;
	PR_DOC_IDESPFORF1		= 204;
	PR_DOC_IDESPFORB1		= 205;
	PR_DOC_IDESPFORF2		= 206;
	PR_DOC_IDESPFORB2		= 207;
	PR_DOC_IDESPF2			= 208;
	PR_DOC_IDESPB2			= 209;
	PR_DOC_DLESPF			= 210;

	//hungarian cheque module
	PR_DOC_POSTAL_CHEQUE	= 301;

	//european health insurance cards
	PR_DOC_E111_5RF			= 401;
	PR_DOC_E111_4RF			= 402;

	//passports
	PR_DOC_PPIND			= 501;
	PR_DOC_PPSGP_P			= 502;
	PR_DOC_PPSGP_PA			= 503;
	PR_DOC_PPSGP_BIO		= 504;
	PR_DOC_IDSGPF1			= 505;

	//albanian module
	PR_DOC_ALB_DLF			= 601;

	//mexican credential
	PR_DOC_MEX_CREDF		= 701;
	PR_DOC_MEX_CREDB		= 702;
	PR_DOC_MEX_CRED1F		= 703;
	PR_DOC_MEX_CRED2F		= 704;
	PR_DOC_MEX_CRED0F		= 705;

	//Hong Kong and Chinese cards
	PR_DOC_IDHKG			= 801;
	PR_DOC_IDCHN			= 802;
	PR_DOC_HKMP				= 803;
	PR_DOC_HKIDC			= 804;
	PR_DOC_IDHKGO			= 805;
	PR_DOC_CHNKE			= 806;
	PR_DOC_CHNOWP			= 807;
	PR_DOC_CHNHVP			= 808;
	PR_DOC_MOADC			= 809;
	PR_DOC_CHNPP			= 810;
	PR_DOC_MCSIDC			= 811;
	PR_DOC_CHNEEP			= 812;
	PR_DOC_CHNPP1			= 813;
	PR_DOC_HKGMTP1			= 814;
	PR_DOC_HKGMTP2			= 815;
	PR_DOC_CHNPP0			= 816;
	PR_DOC_CHNPS			= 817;
	PR_DOC_CHNPT			= 818;
	PR_DOC_MCSIDCF			= 819;
	PR_DOC_CHNHRP			= 820;
	PR_DOC_IDMACF821		= 821;
	PR_DOC_IDMACB822		= 822;

	//South African module
	PR_DOC_IDRSA1			= 901;
	PR_DOC_IDRSA2			= 902;

	//Dutch driving licenses
	PR_DOC_DLNLDF			= 1001;
	PR_DOC_DLNLDB			= 1002;
	PR_DOC_DLNLDO			= 1003;
	PR_DOC_IDNLDF			= 1004;
	PR_DOC_IDNLDB			= 1005;
	PR_DOC_NDLNLDF			= 1006;
	PR_DOC_NDLNLDB			= 1007;
	PR_DOC_DLNLDO2			= 1008;

	//Australian driving licenses
	PR_DOC_DLAUSWAF			= 1101;
	PR_DOC_DLAUSNSW1		= 1102;
	PR_DOC_DLAUSNSW2		= 1103;
	PR_DOC_DLAUSVF			= 1104;
	PR_DOC_PAAUSWAF			= 1105;
	PR_DOC_DLAUSVPF			= 1106;
	PR_DOC_DLAUSV1F			= 1107;
	PR_DOC_DLAUSV1PF		= 1108;
	PR_DOC_PCAUSNSW			= 1109;
	PR_DOC_DLAUSNT1			= 1110;
	PR_DOC_DLAUSNT2			= 1111;
	PR_DOC_DLAUSNT1P		= 1112;
	PR_DOC_DLAUSSA			= 1113;
	PR_DOC_PAAUSSA			= 1114;
	PR_DOC_PAAUSQL			= 1115;
	PR_DOC_DLAUSQL1			= 1116;
	PR_DOC_DLAUSQL2			= 1117;
	PR_DOC_DLAUSQL3			= 1118;
	PR_DOC_DLAUSWA1F		= 1119;
	PR_DOC_DLAUSWA1PF		= 1120;
	PR_DOC_PAAUSVF			= 1121;
	PR_DOC_KPAUS			= 1122;
	PR_DOC_DLAUSACTF		= 1123;
	PR_DOC_PAAUSACTF		= 1124;
	PR_DOC_DLAUSQL4			= 1125;
	PR_DOC_PAAUSQL2			= 1126;
	PR_DOC_PAAUSSA1			= 1161;
	PR_DOC_DLAUSSA1			= 1171;
	PR_DOC_DLAUSWA2F		= 1173;
	PR_DOC_DLAUSWA2PF		= 1175;

	//Poland
	PR_DOC_POLIDF1			= 1201;
	PR_DOC_POLIDB1			= 1202;
	PR_DOC_POLDLF1			= 1203;
	PR_DOC_POLDLFO			= 1204;
	PR_DOC_POLSTCD			= 1205;

	//Slovak documents
	PR_DOC_SLOIDOF1			= 1301;
	PR_DOC_SLOIDOB1			= 1302;
	PR_DOC_SLOIDF1			= 1303;
	PR_DOC_SLOIDFO			= 1304;

	//Croatian documents
	PR_DOC_HRVIDF1			= 1401;
	PR_DOC_HRVIDB1			= 1402;
	PR_DOC_HRVIDF2			= 1403;
	PR_DOC_HRVIDB2			= 1404;

	//Saudi Arabia
	PR_DOC_DLSAU			= 1501;
	PR_DOC_RPSAU			= 1502;
	PR_DOC_LCUAE			= 1503;
	PR_DOC_RPUAE			= 1504;
	PR_DOC_RPSAU2		   	= 1505;

	//United Kingdom
	PR_DOC_DLGBR1F			= 1601;
	PR_DOC_DLGBR2F			= 1602;
	PR_DOC_DLPGBR1F			= 1603;

	//Other documents
	PR_DOC_CZEPPD			= 2001;
	PR_DOC_GERPPD			= 2002;
	PR_DOC_UKPP				= 2003;
	PR_DOC_NLDPP			= 2004;
	PR_DOC_NLDPPD			= 2005;
	PR_DOC_PORPP			= 2006;
	PR_DOC_SWEPPE			= 2007;
	PR_DOC_SWEPP			= 2008;
	PR_DOC_UKTD				= 2009;
	PR_DOC_FINPPS			= 2010;
	PR_DOC_FINPP			= 2011;
	PR_DOC_FINPPD			= 2012;
	PR_DOC_FRAPP			= 2013;
	PR_DOC_FRAPPO			= 2014;
	PR_DOC_RUSPPS			= 2015;
	PR_DOC_RUSPPD			= 2016;
	PR_DOC_TWNPP			= 2017;
	PR_DOC_PAKPP			= 2018;
	PR_DOC_AUSPP			= 2019;
	PR_DOC_CZEPP0			= 2020;
	PR_DOC_DNKPP			= 2021;
	PR_DOC_ITAPP			= 2022;
	PR_DOC_JPNPP1			= 2023;
	PR_DOC_KORPP			= 2024;
	PR_DOC_NORPP1			= 2026;
	PR_DOC_POLPPS			= 2027;
	PR_DOC_USAPP			= 2028;
	PR_DOC_AUTPP			= 2029;
	PR_DOC_BELPP			= 2030;
	PR_DOC_SVKPPD			= 2031;
	PR_DOC_GERPP			= 2032;
	PR_DOC_BGRPP			= 2033;
	PR_DOC_ESTPP			= 2034;
	PR_DOC_SVNPP			= 2035;
	PR_DOC_ESPPP			= 2036;
	PR_DOC_IRLPP			= 2037;
	PR_DOC_GRCPP			= 2038;
	PR_DOC_LTUPP			= 2039;
	PR_DOC_LUXPP			= 2040;
	PR_DOC_LVAPP			= 2041;
	PR_DOC_MLTPP1			= 2042;
	PR_DOC_ROUPP1			= 2043;
	PR_DOC_POLPP1			= 2044;
	PR_DOC_RUSPP			= 2045;
	PR_DOC_CZEPPA			= 2047;
	PR_DOC_ARHPP			= 2049;
	PR_DOC_EGYPP			= 2050;
	PR_DOC_MYSPP			= 2051;
	PR_DOC_OMNPP			= 2052;
	PR_DOC_QATPP1			= 2053;
	PR_DOC_SAUPPP			= 2054;
	PR_DOC_ANDPP			= 2055;
	PR_DOC_ALBPP			= 2056;
	PR_DOC_BIHPPD			= 2057;
	PR_DOC_BLRPP			= 2058;
	PR_DOC_CHEPP1			= 2059;
	PR_DOC_CYPPP1			= 2060;
	PR_DOC_BIHPPS			= 2061;
	PR_DOC_DNKPPFI			= 2062;
	PR_DOC_HRVPPS			= 2063;
	PR_DOC_DNKPPT			= 2064;
	PR_DOC_ISLPP1			= 2065;
	PR_DOC_LVAPPS			= 2066;
	PR_DOC_MDVPP			= 2067;
	PR_DOC_MKDPP			= 2068;
	PR_DOC_MLAPP			= 2069;
	PR_DOC_MKDPPS			= 2070;
	PR_DOC_POLPPD			= 2071;
	PR_DOC_MNEPP			= 2072;
	PR_DOC_MNEPPD			= 2073;
	PR_DOC_SMRPP1			= 2074;
	PR_DOC_SRBPPD			= 2075;
	PR_DOC_SRBPP			= 2076;
	PR_DOC_SVKPPS			= 2077;
	PR_DOC_THAPP			= 2078;
	PR_DOC_TWNPP0			= 2079;
	PR_DOC_ZAFPP			= 2080;
	PR_DOC_ARGPP			= 2081;
	PR_DOC_BRAPP1			= 2082;
	PR_DOC_VNMPP			= 2083;
	PR_DOC_CANPP			= 2084;
	PR_DOC_UKRPP			= 2085;
	PR_DOC_GEOPP1			= 2086;
	PR_DOC_IDNPP			= 2087;
	PR_DOC_PRYPP			= 2088;
	PR_DOC_ISRPP			= 2089;
	PR_DOC_IRQPPS			= 2090;
	PR_DOC_PHLPP			= 2091;
	PR_DOC_NZLPP			= 2092;
	PR_DOC_NGAPPD			= 2093;
	PR_DOC_IRNPPD			= 2094;
	PR_DOC_KENPP			= 2095;
	PR_DOC_KORPPS			= 2096;
	PR_DOC_MEXPP			= 2097;
	PR_DOC_LBNPP			= 2098;
	PR_DOC_BGRPP1			= 2099;
	PR_DOC_CZEPP1			= 2100;
	PR_DOC_ESTPP1			= 2101;
	PR_DOC_GERVS			= 2102;
	PR_DOC_TUNPPDS			= 2103;
	PR_DOC_TUNPP			= 2104;
	PR_DOC_MARPP			= 2106;
	PR_DOC_CHNPP2			= 2107;
	PR_DOC_CHNPP3			= 2108;
	PR_DOC_TURPP			= 2109;
	PR_DOC_PHLPP1			= 2110;
	PR_DOC_ZAFPD			= 2111;
	PR_DOC_ZAFPP1			= 2112;
	PR_DOC_ZAFPO			= 2114;
	PR_DOC_ZAFPE			= 2115;
	PR_DOC_ZAFPT1			= 2116;
	PR_DOC_ZAFPC			= 2119;
	PR_DOC_ZAFPT			= 2120;
	PR_DOC_BELVS			= 2122;
	PR_DOC_NLDVS			= 2125;
	PR_DOC_INDPP			= 2126;
	PR_DOC_ALBPD			= 2127;
	PR_DOC_ALBPS			= 2128;
	PR_DOC_BFAPD			= 2129;
	PR_DOC_BFAPP			= 2130;
	PR_DOC_BFAPP1			= 2131;
	PR_DOC_BFAPS			= 2132;
	PR_DOC_CIVPP			= 2133;
	PR_DOC_CODPD			= 2134;
	PR_DOC_CODPP			= 2135;
	PR_DOC_CODPS			= 2136;
	PR_DOC_CODPP1			= 2137;
	PR_DOC_GMBPP			= 2138;
	PR_DOC_LBRPD			= 2139;
	PR_DOC_LBRPP			= 2140;
	PR_DOC_LBRPS			= 2141;
	PR_DOC_NLDPP1			= 2142;
	PR_DOC_PANPP			= 2143;
	PR_DOC_PEPP				= 2144;
	PR_DOC_PEPP1			= 2145;
	PR_DOC_SMRPP2			= 2148;
	PR_DOC_HRVPD2			= 2149;
	PR_DOC_HRVPP1			= 2150;
	PR_DOC_INDPP1			= 2151;
	PR_DOC_LBRPO			= 2152;
	PR_DOC_IRNPP1			= 2153;
	PR_DOC_FRAVS			= 2154;
	PR_DOC_GHAPP			= 2155;
	PR_DOC_HKGPP1			= 2156;
	PR_DOC_PAKPP1			= 2158;
	PR_DOC_RUSPP1			= 2159;
	PR_DOC_LKAPP			= 2160;
	PR_DOC_LKAPP1			= 2161;
	PR_DOC_CHNPP4			= 2162;
	PR_DOC_THAPP1			= 2164;
	PR_DOC_IRNPS			= 2165;
	PR_DOC_IRNPP			= 2166;
	PR_DOC_NLDPP2			= 2167;
	PR_DOC_AUTVS			= 2168;
	PR_DOC_CZEVS			= 2169;
	PR_DOC_ESPVS			= 2170;
	PR_DOC_FINVS			= 2171;
	PR_DOC_FRAVS1			= 2172;
	PR_DOC_GBRVS			= 2173;
	PR_DOC_GRCVS			= 2174;
	PR_DOC_HUNVS			= 2175;
	PR_DOC_ITAVS			= 2176;
	PR_DOC_LTUVS			= 2177;
	PR_DOC_SWEVS			= 2178;
	PR_DOC_MLTVS			= 2179;
	PR_DOC_NORVS			= 2180;
	PR_DOC_POLVS			= 2181;
	PR_DOC_SVKVS			= 2182;
	PR_DOC_IRNPD			= 2184;
	PR_DOC_LIEPD1			= 2445;
	PR_DOC_LIEPP			= 2447;
	PR_DOC_PHLPP2			= 2567;
	PR_DOC_SVNPP1			= 2625;
	PR_DOC_SYRPP			= 2699;
	PR_DOC_SURPP			= 2700;
	PR_DOC_LIEPP1			= 2701;
	PR_DOC_IDROUF2706		= 2706;
	PR_DOC_IDCZEF2707		= 2707;

	PR_DOC_IDDEUF2710		= 2710;
	PR_DOC_IDDEUF2714		= 2714;
	PR_DOC_DLAUTF			= 2716;
	PR_DOC_IDFRAF2718		= 2718;
	PR_DOC_IDFRAB2719		= 2719;
	PR_DOC_IDCZEF2759		= 2759;
	PR_DOC_DLTHAF2805		= 2805;
	PR_DOC_DLTHAF2806		= 2806;
	PR_DOC_DLTHAF2807		= 2807;
	PR_DOC_IDCZEF2874		= 2874;
	PR_DOC_IDDEUF2879		= 2879;

	PR_DOC_IDNLDF3058		= 3058;
	PR_DOC_RPNLDF3059		= 3059;
	PR_DOC_IDROUF3088		= 3088;
	PR_DOC_IDNLDB3180		= 3180;
	PR_DOC_RPNLDF3182		= 3182;
	PR_DOC_DLUSAFLF3200		= 3200;
	PR_DOC_DLUSACAF3201		= 3201;
	PR_DOC_DLUSAORF3202		= 3202;
	PR_DOC_DLUSAFLF3203		= 3203;
	PR_DOC_RPDEUF3204		= 3204;
	PR_DOC_PPOTHA3206		= 3206;
	PR_DOC_RPFRAF3207		= 3207;
	PR_DOC_RPFRAB3208		= 3208;

	PR_DOC_DLSAUF3241		= 3241;
	PR_DOC_IDIDNF3254		= 3254;
	PR_DOC_IDIDNF3255		= 3255;
	PR_DOC_IDDEUB3266		= 3266;
	PR_DOC_PPNLD3289		= 3289;
	PR_DOC_IDMYSF3300		= 3300;
	PR_DOC_DLITAF3358		= 3358;
	PR_DOC_IDSGPF3362		= 3362;
	PR_DOC_DLSGPF3363		= 3363;
	PR_DOC_IDSGPF3364		= 3364;
	PR_DOC_IDMYSF3367		= 3367;
	PR_DOC_IDTHAF3369		= 3369;
	PR_DOC_IDSAUB3371		= 3371;
	PR_DOC_IDSAUF3377		= 3377;
	PR_DOC_IDDEUF3457		= 3457;
	PR_DOC_DLIDNF3462		= 3462;
	PR_DOC_DLITAB3463		= 3463;
	PR_DOC_DLITAF3499		= 3499;
	PR_DOC_DLITAB3500		= 3500;
	PR_DOC_DLCZEF3501		= 3501;
	PR_DOC_IDSGPF3536		= 3536;
	PR_DOC_IDSGPF3537		= 3537;
	PR_DOC_IDSGPF3538		= 3538;
	PR_DOC_IDSGPF3539		= 3539;
	PR_DOC_SPSGPF3540		= 3540;
	PR_DOC_EPSGPF3541		= 3541;
	PR_DOC_WPSGPF3542		= 3542;
	PR_DOC_IDSGPF3543		= 3543;


//Field Code Values
{ PR_DOCFIELD }

	PR_DF_UNKNOWN				= 0;

	PR_DF_BLOCK					= 1000;
	PR_DF_PARTS					= 0100;

	PR_DFE_COMPOSITE1			= 1;
	PR_DFE_COMPOSITE2			= 2;
	PR_DFE_COMPOSITE3			= 3;
	PR_DFE_COMPOSITE4			= 4;
	PR_DFE_COMPOSITE5			= 5;

	PR_DFE_NAME					= 101;
	PR_DFE_GIVENNAME			= 102;
	PR_DFE_SURNAME				= 103;
	PR_DFE_SURNAME2				= 104;
	PR_DFE_MIDDLENAME			= 105;
	PR_DFE_MAIDEN_NAME			= 107;
	PR_DFE_MAIDEN_GIVENNAME		= 108;
	PR_DFE_MAIDEN_SURNAME		= 109;

	PR_DFE_BIRTH_DATE			= 113;
	PR_DFE_BIRTH_PLACE			= 114;
	PR_DFE_BIRTH_COUNTRY		= 115;
	PR_DFE_MOTHER_NAME			= 116;
	PR_DFE_MOTHER_GIVENNAME		= 117;
	PR_DFE_MOTHER_SURNAME		= 118;

	PR_DFE_NATIONALITY			= 119;
	PR_DFE_SEX					= 120;
	PR_DFE_BIRTH_PROVINCE		= 121;
	PR_DFE_PARENTS_NAME			= 122;
	PR_DFE_FATHER_NAME			= 123;
	PR_DFE_MARITAL_STATUS		= 124;
	PR_DFE_FATHER_GIVENNAME		= 125;
	PR_DFE_FATHER_SURNAME		= 126;

	PR_DFE_DOCUMENT_NUMBER		= 130;
	PR_DFE_TYPE					= 131;
	PR_DFE_ISSUE_COUNTRY		= 132;
	PR_DFE_ISSUE_PLACE			= 133;
	PR_DFE_ISSUE_STATE			= 134;
	PR_DFE_ISSUE_DATE			= 135;
	PR_DFE_EXPIRY_DATE			= 136;
	PR_DFE_ISSUE_ORG			= 137;
	PR_DFE_PROVISIONAL_END_DATE	= 138;

	PR_DFE_PERSONAL_NUMBER		= 140;
	PR_DFE_HEALTH_INS_NUMBER	= 141;
	PR_DFE_REGISTRATION_NUMBER	= 142;
	PR_DFE_DUF_NUMBER			= 143;
	PR_DFE_CAN					= 144;

	PR_DFE_DOCTYPE				= 149;
	PR_DFE_DOCPAGE				= 150;
	PR_DFE_DTDISC				= 151;

	PR_DFE_PERSONAL_DATA1		= 160;
	PR_DFE_PERSONAL_DATA2		= 161;

	PR_DFE_ADDRESS				= 200;
	PR_DFE_ADDR_ZIP				= 201;
	PR_DFE_ADDR_CITY			= 202;
	PR_DFE_ADDR_STREET			= 203;
	PR_DFE_ADDR_HOUSE			= 204;
	PR_DFE_ADDR_FLAT			= 205;
	PR_DFE_ADDR_DATE			= 206;
	PR_DFE_ADDR_STATE			= 209;
	PR_DFE_ADDR_PROVINCE		= 210;
	PR_DFE_ADDR_MUNICIPALITY	= 212;

	PR_DFE_TEMPADDRESS			= 220;
	PR_DFE_TEMPADDR_ZIP			= 221;
	PR_DFE_TEMPADDR_CITY		= 222;
	PR_DFE_TEMPADDR_STREET		= 223;
	PR_DFE_TEMPADDR_HOUSE		= 224;
	PR_DFE_TEMPADDR_FLAT		= 225;
	PR_DFE_TEMPADDR_DATE		= 226;
	PR_DFE_TEMPADDR_DATEEND		= 227;
	PR_DFE_TEMPADDR_STATE		= 229;
	PR_DFE_TEMPADDR_PROVINCE	= 230;
	PR_DFE_TEMPADDR_MUNICIPALITY= 232;

	PR_DFE_VALID_AREA			= 240;
	PR_DFE_START_OF_VALIDITY	= 241;
	PR_DFE_NUMBER_OF_ENTRIES	= 242;
	PR_DFE_DURATION_OF_STAY		= 243;

	PR_DFE_REFERENCE			= 300;
	PR_DFE_AMOUNT				= 301;
	PR_DFE_BANK_ACCOUNT			= 302;
	PR_DFE_POSTAL_REFERENCE		= 303;
	PR_DFE_TRANSACTION_CODE		= 304;
	PR_DFE_SUPPLIER				= 305;
	PR_DFE_OUTPUT_CODE			= 306;

	PR_DFE_FROMADDR				= 320;
	PR_DFE_DESTADDR				= 321;
	PR_DFE_FLIGHTNO				= 322;
	PR_DFE_COMPARTMENT			= 323;
	PR_DFE_SEATNO				= 324;
	PR_DFE_CHECKINSEQ			= 325;

	PR_DFE_FACE					= 400;
	PR_DFE_SIGNATURE			= 420;
	PR_DFE_FINGERPRINT			= 430;
	PR_DFE_IRIS					= 440;
	PR_DFE_BIODATA				= 450;

	PR_DFE_HEIGHT				= 490;
	PR_DFE_WEIGHT				= 491;
	PR_DFE_EYECOLOR				= 492;
	PR_DFE_HAIRCOLOR			= 493;

	PR_DFE_AUTHENTICITY			= 500;
	PR_DFE_AUTHENTICITY1		= 501;
	PR_DFE_AUTHENTICITY2		= 502;
	PR_DFE_AUTHENTICITY3		= 503;
	PR_DFE_AUTHENTICITY4		= 504;
	PR_DFE_AUTHENTICITY5		= 505;

	PR_DFE_TELEPHONE			= 600;
	PR_DFE_PROFESSION			= 601;
	PR_DFE_TITLE				= 602;
	PR_DFE_PERSONAL_SUMMARY		= 603;
	PR_DFE_PROOF_OF_CITIZENSHIP	= 604;
	PR_DFE_OTHER_TD_NUMBERS		= 605;
	PR_DFE_CUSTODY_INFORMATION	= 606;
	PR_DFE_OTHER_NAME			= 607;
	PR_DFE_OTHER_PEOPLE			= 608;
	PR_DFE_OBSERVATIONS			= 609;
	PR_DFE_TAX					= 610;
	PR_DFE_FRONT_IMAGE			= 611;
	PR_DFE_REAR_IMAGE			= 612;
	PR_DFE_PERSONALIZATION_DATE	= 613;
	PR_DFE_PERSONALIZATION_SYSTEM	= 614;
	PR_DFE_ORGAN_DONOR			= 615;
	PR_DFE_REMARKS				= 616;
	PR_DFE_BLOODTYPE			= 617;
	PR_DFE_RANK					= 618;
	PR_DFE_SERVICE_BRANCH		= 619;

	PR_DFE_CAR					= 620;
	PR_DFE_CHR					= 621;

	PR_DFE_LOWLEVEL				= 997;
	PR_DFE_FORMAT_CHECK			= 998;
	PR_DFE_DOCUMENT_DESCRIPTOR	= 999;

	//Machine Readable Zone (MRZ)
	PR_DF_MRZ_FIELDS			= 1000;

	PR_DF_MRZ1					= PR_DF_MRZ_FIELDS + PR_DFE_COMPOSITE1;
	PR_DF_MRZ2					= PR_DF_MRZ_FIELDS + PR_DFE_COMPOSITE2;
	PR_DF_MRZ3					= PR_DF_MRZ_FIELDS + PR_DFE_COMPOSITE3;

	PR_DF_MRZ_NAME				= PR_DF_MRZ_FIELDS + PR_DFE_NAME;
	PR_DF_MRZ_GIVENNAME			= PR_DF_MRZ_FIELDS + PR_DFE_GIVENNAME;
	PR_DF_MRZ_SURNAME			= PR_DF_MRZ_FIELDS + PR_DFE_SURNAME;
	PR_DF_MRZ_BIRTH_DATE		= PR_DF_MRZ_FIELDS + PR_DFE_BIRTH_DATE;
	PR_DF_MRZ_NATIONALITY		= PR_DF_MRZ_FIELDS + PR_DFE_NATIONALITY;
	PR_DF_MRZ_SEX				= PR_DF_MRZ_FIELDS + PR_DFE_SEX;

	PR_DF_MRZ_DOCUMENT_NUMBER	= PR_DF_MRZ_FIELDS + PR_DFE_DOCUMENT_NUMBER;
	PR_DF_MRZ_TYPE				= PR_DF_MRZ_FIELDS + PR_DFE_TYPE;
	PR_DF_MRZ_ISSUE_COUNTRY		= PR_DF_MRZ_FIELDS + PR_DFE_ISSUE_COUNTRY;
	PR_DF_MRZ_ISSUE_STATE		= PR_DF_MRZ_FIELDS + PR_DFE_ISSUE_STATE;
	PR_DF_MRZ_EXPIRY_DATE		= PR_DF_MRZ_FIELDS + PR_DFE_EXPIRY_DATE;

	PR_DF_MRZ_PERSONAL_DATA		= PR_DF_MRZ_FIELDS + PR_DFE_PERSONAL_DATA1;
	PR_DF_MRZ_PERSONAL_DATA2	= PR_DF_MRZ_FIELDS + PR_DFE_PERSONAL_DATA2;

	PR_DF_MRZ_REFERENCE			= PR_DF_MRZ_FIELDS + PR_DFE_REFERENCE;
	PR_DF_MRZ_AMOUNT			= PR_DF_MRZ_FIELDS + PR_DFE_AMOUNT;
	PR_DF_MRZ_BANK_ACCOUNT		= PR_DF_MRZ_FIELDS + PR_DFE_BANK_ACCOUNT;
	PR_DF_MRZ_POSTAL_REFERENCE	= PR_DF_MRZ_FIELDS + PR_DFE_POSTAL_REFERENCE;
	PR_DF_MRZ_TRANSACTION_CODE	= PR_DF_MRZ_FIELDS + PR_DFE_TRANSACTION_CODE;
	PR_DF_MRZ_SUPPLIER			= PR_DF_MRZ_FIELDS + PR_DFE_SUPPLIER;
	PR_DF_MRZ_OUTPUT_CODE		= PR_DF_MRZ_FIELDS + PR_DFE_OUTPUT_CODE;

	PR_DF_MRZ_AUTH_B900			= 1551;

	//Visual Inspection Zone (VIZ)
	PR_DF_VIZ_FIELDS			= 2000;

	PR_DF_VIZ1					= PR_DF_VIZ_FIELDS + PR_DFE_COMPOSITE1;
	PR_DF_VIZ2					= PR_DF_VIZ_FIELDS + PR_DFE_COMPOSITE2;
	PR_DF_VIZ3					= PR_DF_VIZ_FIELDS + PR_DFE_COMPOSITE3;

	PR_DF_VIZ_NAME				= PR_DF_VIZ_FIELDS + PR_DFE_NAME;
	PR_DF_VIZ_GIVENNAME			= PR_DF_VIZ_FIELDS + PR_DFE_GIVENNAME;
	PR_DF_VIZ_SURNAME			= PR_DF_VIZ_FIELDS + PR_DFE_SURNAME;
	PR_DF_VIZ_SURNAME2			= PR_DF_VIZ_FIELDS + PR_DFE_SURNAME2;
	PR_DF_VIZ_MIDDLENAME		= PR_DF_VIZ_FIELDS + PR_DFE_MIDDLENAME;
	PR_DF_VIZ_MAIDEN_NAME		= PR_DF_VIZ_FIELDS + PR_DFE_MAIDEN_NAME;

	PR_DF_VIZ_BIRTH_DATE		= PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_DATE;
	PR_DF_VIZ_BIRTH_PLACE		= PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_PLACE;
	PR_DF_VIZ_BIRTH_COUNTRY		= PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_COUNTRY;
	PR_DF_VIZ_MOTHER_NAME		= PR_DF_VIZ_FIELDS + PR_DFE_MOTHER_NAME;
	PR_DF_VIZ_NATIONALITY		= PR_DF_VIZ_FIELDS + PR_DFE_NATIONALITY;
	PR_DF_VIZ_SEX				= PR_DF_VIZ_FIELDS + PR_DFE_SEX;
	PR_DF_VIZ_BIRTH_PROVINCE	= PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_PROVINCE;
	PR_DF_VIZ_PARENTS_NAME		= PR_DF_VIZ_FIELDS + PR_DFE_PARENTS_NAME;

	PR_DF_VIZ_DOCUMENT_NUMBER	= PR_DF_VIZ_FIELDS + PR_DFE_DOCUMENT_NUMBER;
	PR_DF_VIZ_TYPE				= PR_DF_VIZ_FIELDS + PR_DFE_TYPE;
	PR_DF_VIZ_ISSUE_COUNTRY		= PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_COUNTRY;
	PR_DF_VIZ_ISSUE_PLACE		= PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_PLACE;
	PR_DF_VIZ_ISSUE_DATE		= PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_DATE;
	PR_DF_VIZ_EXPIRY_DATE		= PR_DF_VIZ_FIELDS + PR_DFE_EXPIRY_DATE;
	PR_DF_VIZ_ISSUE_ORG			= PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_ORG;

	PR_DF_VIZ_PERSONAL_NUMBER	= PR_DF_VIZ_FIELDS + PR_DFE_PERSONAL_NUMBER;
	PR_DF_VIZ_HEALTH_INS_NUMBER	= PR_DF_VIZ_FIELDS + PR_DFE_HEALTH_INS_NUMBER;

	PR_DF_VIZ_ADDRESS			= PR_DF_VIZ_FIELDS + PR_DFE_ADDRESS;
	PR_DF_VIZ_ADDR_ZIP			= PR_DF_VIZ_FIELDS + PR_DFE_ADDR_ZIP;
	PR_DF_VIZ_ADDR_CITY			= PR_DF_VIZ_FIELDS + PR_DFE_ADDR_CITY;
	PR_DF_VIZ_ADDR_STREET		= PR_DF_VIZ_FIELDS + PR_DFE_ADDR_STREET;
	PR_DF_VIZ_ADDR_HOUSE		= PR_DF_VIZ_FIELDS + PR_DFE_ADDR_HOUSE;
	PR_DF_VIZ_ADDR_FLAT			= PR_DF_VIZ_FIELDS + PR_DFE_ADDR_FLAT;
	PR_DF_VIZ_ADDR_DATE			= PR_DF_VIZ_FIELDS + PR_DFE_ADDR_DATE;
	PR_DF_VIZ_ADDR_PROVINCE		= PR_DF_VIZ_FIELDS + PR_DFE_ADDR_PROVINCE;

	PR_DF_VIZ_TEMPADDRESS		= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDRESS;
	PR_DF_VIZ_TEMPADDR_ZIP		= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_ZIP;
	PR_DF_VIZ_TEMPADDR_CITY		= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_CITY;
	PR_DF_VIZ_TEMPADDR_STREET	= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_STREET;
	PR_DF_VIZ_TEMPADDR_HOUSE	= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_HOUSE;
	PR_DF_VIZ_TEMPADDR_FLAT		= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_FLAT;
	PR_DF_VIZ_TEMPADDR_DATE		= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_DATE;
	PR_DF_VIZ_TEMPADDR_DATEEND	= PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_DATEEND;

	PR_DF_VIZ_REFERENCE			= PR_DF_VIZ_FIELDS + PR_DFE_REFERENCE;
	PR_DF_VIZ_AMOUNT			= PR_DF_VIZ_FIELDS + PR_DFE_AMOUNT;
//	PR_DF_VIZ_BANK_ACCOUNT		= PR_DF_VIZ_FIELDS + PR_DFE_BANK_ACCOUNT;

	PR_DF_VIZ_FACE				= PR_DF_VIZ_FIELDS + PR_DFE_FACE;
	PR_DF_VIZ_SIGNATURE			= PR_DF_VIZ_FIELDS + PR_DFE_SIGNATURE;
	PR_DF_VIZ_FINGERPRINT		= PR_DF_VIZ_FIELDS + PR_DFE_FINGERPRINT;
	PR_DF_VIZ_IRIS				= PR_DF_VIZ_FIELDS + PR_DFE_IRIS;

	PR_DF_VIZ_AUTHENTICITY		= PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY;
	PR_DF_VIZ_AUTHENTICITY1		= PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY1;
	PR_DF_VIZ_AUTHENTICITY2		= PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY2;
	PR_DF_VIZ_AUTHENTICITY3		= PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY3;
	PR_DF_VIZ_AUTHENTICITY4		= PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY4;
	PR_DF_VIZ_AUTHENTICITY5		= PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY5;

	PR_DF_VIZ_AUTH_COMPOSITE	= 2500;
	PR_DF_VIZ_AUTH_DOCAREA		= 2551;
	PR_DF_VIZ_AUTH_ACCORDANCE	= 2552;
	PR_DF_VIZ_AUTH_UVFIBRES		= 2553;

	//Barcode Reading (BC)
	PR_DF_BC_FIELDS				= 3000;

	PR_DF_BC1					= PR_DF_BC_FIELDS + PR_DFE_COMPOSITE1;

	//Magnetic Stripe (MS)
	PR_DF_MS_FIELDS				= 4000;

	// RFID data
	PR_DF_RFID_FIELDS			= $400000;

	PR_DF_RFID_MRZ				= PR_DF_RFID_FIELDS or $010000;
	PR_DF_RFID_FACE				= PR_DF_RFID_FIELDS or $020000;
	PR_DF_RFID_FINGERPRINT		= PR_DF_RFID_FIELDS or $030000;
	PR_DF_RFID_IRIS				= PR_DF_RFID_FIELDS or $040000;
	PR_DF_RFID_SIGNATURE		= PR_DF_RFID_FIELDS or $050000;

	//Final formatted data
	PR_DF_FORMATTED				= 10000;

	PR_DF_NAME					= PR_DF_FORMATTED + PR_DFE_NAME;
	PR_DF_GIVENNAME				= PR_DF_FORMATTED + PR_DFE_GIVENNAME;
	PR_DF_SURNAME				= PR_DF_FORMATTED + PR_DFE_SURNAME;
	PR_DF_SURNAME2				= PR_DF_FORMATTED + PR_DFE_SURNAME2;
	PR_DF_MIDDLENAME			= PR_DF_FORMATTED + PR_DFE_MIDDLENAME;
	PR_DF_MAIDEN_NAME			= PR_DF_FORMATTED + PR_DFE_MAIDEN_NAME;
	PR_DF_MAIDEN_GIVENNAME		= PR_DF_FORMATTED + PR_DFE_MAIDEN_GIVENNAME;
	PR_DF_MAIDEN_SURNAME		= PR_DF_FORMATTED + PR_DFE_MAIDEN_SURNAME;

	PR_DF_BIRTH_DATE			= PR_DF_FORMATTED + PR_DFE_BIRTH_DATE;
	PR_DF_BIRTH_PLACE			= PR_DF_FORMATTED + PR_DFE_BIRTH_PLACE;
	PR_DF_BIRTH_COUNTRY			= PR_DF_FORMATTED + PR_DFE_BIRTH_COUNTRY;
	PR_DF_MOTHER_NAME			= PR_DF_FORMATTED + PR_DFE_MOTHER_NAME;
	PR_DF_MOTHER_GIVENNAME		= PR_DF_FORMATTED + PR_DFE_MOTHER_GIVENNAME;
	PR_DF_MOTHER_SURNAME		= PR_DF_FORMATTED + PR_DFE_MOTHER_SURNAME;

	PR_DF_NATIONALITY			= PR_DF_FORMATTED + PR_DFE_NATIONALITY;
	PR_DF_SEX					= PR_DF_FORMATTED + PR_DFE_SEX;
	PR_DF_BIRTH_PROVINCE		= PR_DF_FORMATTED + PR_DFE_BIRTH_PROVINCE;
	PR_DF_PARENTS_NAME			= PR_DF_FORMATTED + PR_DFE_PARENTS_NAME;

	PR_DF_DOCUMENT_NUMBER		= PR_DF_FORMATTED + PR_DFE_DOCUMENT_NUMBER;
	PR_DF_TYPE					= PR_DF_FORMATTED + PR_DFE_TYPE;
	PR_DF_ISSUE_COUNTRY			= PR_DF_FORMATTED + PR_DFE_ISSUE_COUNTRY;
	PR_DF_ISSUE_PLACE			= PR_DF_FORMATTED + PR_DFE_ISSUE_PLACE;
	PR_DF_ISSUE_STATE			= PR_DF_FORMATTED + PR_DFE_ISSUE_STATE;
	PR_DF_ISSUE_DATE			= PR_DF_FORMATTED + PR_DFE_ISSUE_DATE;
	PR_DF_EXPIRY_DATE			= PR_DF_FORMATTED + PR_DFE_EXPIRY_DATE;
	PR_DF_ISSUE_ORG				= PR_DF_FORMATTED + PR_DFE_ISSUE_ORG;

	PR_DF_PERSONAL_NUMBER		= PR_DF_FORMATTED + PR_DFE_PERSONAL_NUMBER;
	PR_DF_HEALTH_INS_NUMBER		= PR_DF_FORMATTED + PR_DFE_HEALTH_INS_NUMBER;

	PR_DF_DOCTYPE				= PR_DF_FORMATTED + PR_DFE_DOCTYPE;

	PR_DF_PERSONAL_DATA			= PR_DF_FORMATTED + PR_DFE_PERSONAL_DATA1;
	PR_DF_PERSONAL_DATA2		= PR_DF_FORMATTED + PR_DFE_PERSONAL_DATA2;

	PR_DF_ADDR_ZIP				= PR_DF_FORMATTED + PR_DFE_ADDR_ZIP;
	PR_DF_ADDR_CITY				= PR_DF_FORMATTED + PR_DFE_ADDR_CITY;
	PR_DF_ADDR_STREET			= PR_DF_FORMATTED + PR_DFE_ADDR_STREET;
	PR_DF_ADDR_HOUSE			= PR_DF_FORMATTED + PR_DFE_ADDR_HOUSE;
	PR_DF_ADDR_FLAT				= PR_DF_FORMATTED + PR_DFE_ADDR_FLAT;
	PR_DF_ADDR_DATE				= PR_DF_FORMATTED + PR_DFE_ADDR_DATE;
	PR_DF_ADDR_PROVINCE			= PR_DF_FORMATTED + PR_DFE_ADDR_PROVINCE;

	PR_DF_TEMPADDR_ZIP			= PR_DF_FORMATTED + PR_DFE_TEMPADDR_ZIP;
	PR_DF_TEMPADDR_CITY			= PR_DF_FORMATTED + PR_DFE_TEMPADDR_CITY;
	PR_DF_TEMPADDR_STREET		= PR_DF_FORMATTED + PR_DFE_TEMPADDR_STREET;
	PR_DF_TEMPADDR_HOUSE		= PR_DF_FORMATTED + PR_DFE_TEMPADDR_HOUSE;
	PR_DF_TEMPADDR_FLAT			= PR_DF_FORMATTED + PR_DFE_TEMPADDR_FLAT;
	PR_DF_TEMPADDR_DATE			= PR_DF_FORMATTED + PR_DFE_TEMPADDR_DATE;
	PR_DF_TEMPADDR_DATEEND		= PR_DF_FORMATTED + PR_DFE_TEMPADDR_DATEEND;
	PR_DF_TEMPADDR_PROVINCE		= PR_DF_FORMATTED + PR_DFE_TEMPADDR_PROVINCE;

	PR_DF_REFERENCE				= PR_DF_FORMATTED + PR_DFE_REFERENCE;
	PR_DF_AMOUNT				= PR_DF_FORMATTED + PR_DFE_AMOUNT;
	PR_DF_BANK_ACCOUNT			= PR_DF_FORMATTED + PR_DFE_BANK_ACCOUNT;
	PR_DF_POSTAL_REFERENCE		= PR_DF_FORMATTED + PR_DFE_POSTAL_REFERENCE;
	PR_DF_TRANSACTION_CODE		= PR_DF_FORMATTED + PR_DFE_TRANSACTION_CODE;
	PR_DF_SUPPLIER				= PR_DF_FORMATTED + PR_DFE_SUPPLIER;
	PR_DF_OUTPUT_CODE			= PR_DF_FORMATTED + PR_DFE_OUTPUT_CODE;

	PR_DF_FACE					= PR_DF_FORMATTED + PR_DFE_FACE;

	PR_DF_HEIGHT				= PR_DF_FORMATTED + PR_DFE_HEIGHT;
	PR_DF_WEIGHT				= PR_DF_FORMATTED + PR_DFE_WEIGHT;
	PR_DF_EYECOLOR				= PR_DF_FORMATTED + PR_DFE_EYECOLOR;

	PR_DF_AUTHENTICITY			= PR_DF_FORMATTED + PR_DFE_AUTHENTICITY;

{ PR_PROP_TYPE }
	PR_PROP_TYPE_BASE			= $000000;
	PR_PROP_TYPE_GENERAL		= $F00000;
	PR_PROP_TYPE_COMPOSITE		= $F10000;

	PR_PROP_TYPE_BARCODE_TYPE	= PR_PROP_TYPE_BASE or $01;
	PR_PROP_TYPE_RFID_FILES		= PR_PROP_TYPE_BASE or $02;
	PR_PROP_TYPE_CONFIDENCE		= PR_PROP_TYPE_BASE or $03;

	PR_PROP_TYPE_FACIAL_RECORD_HEADER	= PR_PROP_TYPE_COMPOSITE or $01;
	PR_PROP_TYPE_FACIAL_INFORMATION		= PR_PROP_TYPE_COMPOSITE or $02;
	PR_PROP_TYPE_FEATURE_POINTS			= PR_PROP_TYPE_COMPOSITE or $03;
	PR_PROP_TYPE_IMAGE_INFORMATION		= PR_PROP_TYPE_COMPOSITE or $04;

{ ITEM_TYPE }
	PR_IT_GENERAL				=0;
	PR_IT_IMAGE					=1;
	PR_IT_IMAGE_GROUP			=2;
	PR_IT_OCR_CHAR				=3;
	PR_IT_OCR_ROW				=4;
	PR_IT_OCR_GROUP				=5;
	PR_IT_BARCODE				=6;
	PR_IT_DOC_CHAR				=7;
	PR_IT_FIELD					=8;
	PR_IT_FIELD_GROUP			=9;
	PR_IT_INTEGRITY				=10;
	PR_IT_INTEGRITY_GROUP		=11;
	PR_IT_DOCUMENT				=12;


implementation
end.
