unit prtypes;
//------------------------------------------------------------------------------
// PR Types file - V2.1.10
//
// 2004-2021 (c) Adaptive Recognition (https://adaptiverecognition.com)
//------------------------------------------------------------------------------
interface
//------------------------------------------------------------------------------
const

// PR_USAGEMODE - Device connection modes
	PR_UMODE_DISCONNECT		= 0;
	PR_UMODE_NORMAL_USE		= 1;
	PR_UMODE_FULL_CONTROL	= 2;

// PR_FREERUNMODE - Device freerun light controlling modes
	PR_FRMODE_NULL			= $0000;
	PR_FRMODE_PREVIEWLIGHT	= $0001;
	PR_FRMODE_UVLEDWARMING	= $0002;
	PR_FRMODE_TESTDOCUMENT	= $0004;

// PR_TESTDOCMODE - Device motion detection methods
	PR_TDM_COMBINED			= 0;
	PR_TDM_COMBINEDMOVEABLE	= 1;
	PR_TDM_FORCEDSOFTWARE	= 2;
	PR_TDM_DELAYEDHARDWARE	= 3;

// PR_WINDOW_ID - Object windows
	PR_OW_MASK				= $ff000000;
	PR_OW_DEFAULT			= $00000000;
	PR_OW_1ST				= $01000000;
	PR_OW_2ND				= $02000000;

// PR_PAGELIGHT_PROP - Options for page light setup
	PR_CAPTURE_CONTINUOUS	= $10000000;
	PR_APPEND_PAGELIGHTS	= $20000000;

// PR_LIGHT - Illuminations
	PR_LIGHT_OFF			=  0;
	PR_LIGHT_WHITE			=  1;
	PR_LIGHT_INFRA			=  2;
	PR_LIGHT_UV				=  3;
	PR_LIGHT_COAXIAL		=  4;
	PR_LIGHT_KINEGRAM		=  5;
	PR_LIGHT_PHOTO			=  6;
	PR_LIGHT_BLUE			= 16;
	PR_LIGHT_RED			= 17;
	PR_LIGHT_CLEANUV		= 19;
	PR_LIGHT_CLEANOVD		= 21;
	PR_LIGHT_EDGE			= 25;

// PR_TESTDOC - Document detection modes
	PR_TD_OUT				= 0;
	PR_TD_MOVE				= 1;
	PR_TD_NOMOVE			= 2;
	PR_TD_IN				= 4;

// PR_BCTYPE - Barcode types
	PR_BCTYPE_EAN8			= 1;
	PR_BCTYPE_EAN13			= 2;
	PR_BCTYPE_CODE39		= 3;
	PR_BCTYPE_CODE128		= 4;
	PR_BCTYPE_PDF417		= 5;
	PR_BCTYPE_INTER25		= 6;
	PR_BCTYPE_DATAMATRIX	= 7;
	PR_BCTYPE_QR			= 8;
	PR_BCTYPE_AZTEC			= 9;
	PR_BCTYPE_UPU			= 10;

// PR_IMAGE_TYPE - Image types
	PR_IT_ORIGINAL			= 0;
	PR_IT_DOCUMENT			= 1;
	PR_IT_PREVIEW			= 2;
	PR_IT_FINGER			= 3;

// PR_EVENT - Event types
	PR_ET_LED				= 1;
	PR_ET_CAPTURE			= 2;
	PR_ET_RFID				= 8;

	PR_EV_UVLEDWARMING		=   1;

	PR_EV_PAGECAPTURED		= 101;
	PR_EV_IMAGECAPTURED		= 102;
	PR_EV_CAPTURESTARTED	= 103;
	PR_EV_NOIMAGEINFO		= 104;
	PR_EV_DOCFRAMEFOUND		= 105;
	PR_EV_FGCAP				= 106;
	PR_EV_PREVIEWCAPTURED	= 107;

	PR_EV_RFAUTH_BEGIN		= 301;
	PR_EV_RFAUTH_WAIT4INPUT	= 302;
	PR_EV_RFAUTH_DONE		= 303;
	PR_EV_RFFILE_BEGIN		= 304;
	PR_EV_RFFILE_DONE		= 305;
	PR_EV_RFFILE_CHECKED	= 306;

// PR_DOCFILEFORMATS - Document file formats
	PR_DFF_XML				= 1;
	PR_DFF_ZIPPED			= 2;
	PR_DFF_AUTH				= 3;
	PR_DFF_ENCZIP			= 4;
	PR_DFF_BSIAUTHLOG		= 5;

// PR_RFID_FILES - Rfid file identifiers
	PR_RFID_EF_COM	= 0;
	PR_RFID_EF_DG1	= 1;
	PR_RFID_EF_DG2	= 2;
	PR_RFID_EF_DG3	= 3;
	PR_RFID_EF_DG4	= 4;
	PR_RFID_EF_DG5	= 5;
	PR_RFID_EF_DG6	= 6;
	PR_RFID_EF_DG7	= 7;
	PR_RFID_EF_DG8	= 8;
	PR_RFID_EF_DG9	= 9;
	PR_RFID_EF_DG10	= 10;
	PR_RFID_EF_DG11	= 11;
	PR_RFID_EF_DG12	= 12;
	PR_RFID_EF_DG13	= 13;
	PR_RFID_EF_DG14	= 14;
	PR_RFID_EF_DG15	= 15;
	PR_RFID_EF_DG16	= 16;
	PR_RFID_EF_DG17	= 17;
	PR_RFID_EF_DG18	= 18;
	PR_RFID_EF_DG19	= 19;
	PR_RFID_EF_DG20	= 20;
	PR_RFID_EF_DG21	= 21;
	PR_RFID_EF_DG22	= 22;
	PR_RFID_EF_CARD_ACCESS	= 28;
	PR_RFID_EF_CARD_SECURITY= 29;
	PR_RFID_EF_CVCA	= 30;
	PR_RFID_EF_SOD	= 31;
	PR_RFID_CF_DS	= 32;
	PR_RFID_CF_CSCA	= 33;
	PR_RFID_EF_ALL	= -1;
	PR_RFID_EF_SEL	= -2;

	PR_RFID_GENERAL_DATA		= 1000;
	PR_RFID_PERSONAL_DETAILS	= 1001;
	PR_RFID_ISSUER_DETAILS		= 1002;
	PR_RFID_PORTRAIT			= 1003;
	PR_RFID_SIGNATURE			= 1004;
	PR_RFID_FACE				= 1005;
	PR_RFID_FINGER				= 1006;
	PR_RFID_IRIS				= 1007;
	PR_RFID_OTHER_BIOMETRIC_DATA = 1008;
	PR_RFID_DOMESTIC_DATA		= 1009;
	PR_RFID_AA_DATA				= 1010;
	PR_RFID_ANY_FACE				= 1011;
	PR_RFID_TOCFILE					= 1012;
	PR_RFID_EAP_DATA				= 1013;

// PR_RFID_MEMOPTS - Memory addressing options for rfid storage cards
	PR_RFID_MEMORY_ADDRESS		= $40000000;
	PR_RFID_BLOCK_ADDRESS		= $20000000;
	PR_RFID_SECTOR_ADDRESS		= $60000000;

// PR_AUTH_PROC - Authentication codes
	PR_NO_AUTH_PROCESS		= 0;
	PR_PASSIVE_AUTH			= 1;
	PR_TERMINAL_AUTH		= 2;
	PR_PACE					= 3;
	PR_BAC					= 4;
	PR_CHIP_AUTH			= 5;
	PR_ACTIVE_AUTH			= 6;
	PR_SELECT_APPLICATION	= 7;
	PR_BAP					= 8;
	PR_BLOCK_AUTH			= 9;
	PR_INIT_TERMINAL_AUTH	= 10;
	PR_COMPLETE_TERMINAL_AUTH = 11;
	PR_STORAGE_CARD_AUTH	= 12;

//PR_REQ_AUTH - Requested authentication level for automatic RF reading
	PR_REQ_MIN_AUTH				= 1;
	PR_REQ_OPT_AUTH				= 2;
	PR_REQ_MAX_AUTH				= 3;


// PR_APP_TYPE - Application types
	PR_APP_NONE			= 0;
	PR_APP_EPASSPORT	= 1;
	PR_APP_EID			= 2;
	PR_APP_ESIGN		= 3;
	PR_APP_ISODL		= 4;
	PR_APP_NFC			= 5;
	PR_APP_EDL			= 6;

// PR_PACE_PASSWORD - Password codes for Password Authenticated Connection Establishment (PACE)
	PR_PACE_PW_MRZ = 1;
	PR_PACE_PW_CAN = 2;
	PR_PACE_PW_PIN = 3;
	PR_PACE_PW_PUK = 4;

// PR_CERTIFICATE_SELECTION - Certificate selection flag
	PR_SEL_CERT_EXPIRED = $100;
	PR_SEL_CERT_REVOKED = $200;

// PR_POWER_STATE - Power state codes
	PR_PWR_MASK				= $000f;

	PR_PWR_UNKNOWN			= $0000;
	PR_PWR_OFF				= $0001;
	PR_PWR_ON				= $0002;
	PR_PWR_DATA				= $0003;

	PR_BATTERY_MASK			= $00f0;

	PR_BATTERY_UNAVAILABLE	= $0000;
	PR_BATTERY_AVAILABLE	= $0010;
	PR_BATTERY_UNKNOWN		= $0020;

// PR_STATUS_LED_COLOR - Status led color codes
	PR_SLC_OFF		= $00;
	PR_SLC_OG		= $02;
	PR_SLC_ORG		= $03;
	PR_SLC_SYSTEM	= $10;
	PR_SLC_GREEN	= $81;
	PR_SLC_RED		= $82;
	PR_SLC_ORANGE	= $83;
	PR_SLC_BLUE		= $84;
	PR_SLC_AUTO		= $ac;
	PR_SLC_ANY		= $ff;

// PR_BUZZER - Id of the buzzer
	PR_SLC_BUZZER	= $c0;

// PR_KEY_STATE - Button state codes
	PR_KEY_UNKNOWN		= 0;
	PR_KEY_PRESSED		= 1;
	PR_KEY_RELEASED		= 2;
	PR_KEY_NOKEY		= 3;

// PR_KEY_CODE - Button codes
	PR_KEY_POWER	= $10101;
	PR_KEY_START	= $10110;

// PR_HWTYPE - Hardware part types
	PR_HW_IO		= 0;
	PR_HW_SCANNER		= 1;
	PR_HW_RFIDREADER	= 2;
	PR_HW_CONTACTREADER	= 3;
	PR_HW_MAGNETICREADER	= 4;

// PR_VAR_ID - Variant IDs used

	PRV_ROOT			= 0;

	PRV_PAGELIST		= PRV_ROOT or 1;
	PRV_TASKLIST		= PRV_ROOT or 2;
	PRV_PERSONINFO		= PRV_ROOT or 3;
	PRV_DOCINFO			= PRV_ROOT or 4;

	PRV_DOCUMENT		= $D0000000;
	PRV_FIELDLIST		= PRV_DOCUMENT or 1;
	PRV_FIELD			= PRV_DOCUMENT or 2;
	PRV_FIELDVALUE		= PRV_DOCUMENT or 3;
	PRV_CHECKSUM		= PRV_DOCUMENT or 4;
	PRV_CONFIDENCE		= PRV_DOCUMENT or 5;
	PRV_WINDOWFRAME		= PRV_DOCUMENT or 6;
	PRV_WINDOWFULLFRAME	= PRV_DOCUMENT or 7;
	PRV_ACCORDANCE		= PRV_DOCUMENT or 8;
	PRV_FMTVALUE		= PRV_DOCUMENT or 9;
	PRV_STDVALUE		= PRV_DOCUMENT or 10;
	PRV_CORRECTION		= PRV_DOCUMENT or 11;
	PRV_FIELDCOMPARES	= PRV_DOCUMENT or 12;
	PRV_CHKDETAILS		= PRV_DOCUMENT or 13;
	PRV_AMID			= PRV_DOCUMENT or 14;

	PRV_IMAGE			= $D0100000;
	PRV_IMAGELIST		= PRV_IMAGE or 1;
	PRV_IMAGEFRAME		= PRV_IMAGE or 2;
	PRV_SAMPLE			= PRV_IMAGE or 3;

	PRV_DEVICE_INFO		= $D0200000;
	PRV_DEVICE_ID		= PRV_DEVICE_INFO or 1;
	PRV_LIGHT			= PRV_DEVICE_INFO or 2;
	PRV_CAPTIME			= PRV_DEVICE_INFO or 3;
	PRV_PAGE			= PRV_DEVICE_INFO or 4;
	PRV_TRAFO			= PRV_DEVICE_INFO or 5;
	PRV_CAMERA			= PRV_DEVICE_INFO or 6;
	PRV_MODE			= PRV_DEVICE_INFO or 8;
	PRV_HWTYPE			= PRV_DEVICE_INFO or 9;
	PRV_STATLEDLIST		= PRV_DEVICE_INFO or 10;
	PRV_KEYBOARD		= PRV_DEVICE_INFO or 11;
	PRV_POWER			= PRV_DEVICE_INFO or 12;
	PRV_VERSION			= PRV_DEVICE_INFO or 13;
	PRV_WINDOWLIST		= PRV_DEVICE_INFO or 14;
	PRV_CAPABILITY		= PRV_DEVICE_INFO or 15;
	PRV_DISPLAY 		= PRV_DEVICE_INFO or 16;

	PRV_BARCODE			= $D0300000;
	PRV_BARCODEVALUE	= PRV_BARCODE or 1;
	PRV_BARCODELIST		= PRV_BARCODE or 2;

	PRV_OCR				= $D0400000;
	PRV_OCRROWLIST		= PRV_OCR or 1;
	PRV_OCRROW			= PRV_OCR or 2;
	PRV_OCRCHAR			= PRV_OCR or 3;

	PRV_OQCA			= PRV_OCR or $00080000;
	PRV_OQC_ROTATION	= PRV_OQCA or 1;
	PRV_OQC_HEIGHT		= PRV_OQCA or 2;
	PRV_OQC_WIDTH		= PRV_OQCA or 3;
	PRV_OQC_HANGOUT		= PRV_OQCA or 4;
	PRV_OQC_DISTANCE	= PRV_OQCA or 5;
	PRV_OQC_CONTRAST	= PRV_OQCA or 6;
	PRV_OQC_SHAPE		= PRV_OQCA or 7;

	PRV_ENGINE			= PRV_OCR or $000A0000;
	PRV_ENG_LIC			= PRV_ENGINE or 1;
	PRV_ENG_LICDATE		= PRV_ENGINE or 2;
	PRV_ENG_LICTYPE		= PRV_ENGINE or 3;

	PRV_RFID			= $D0500000;
	PRV_RFIDDIR			= PRV_RFID or 1;
	PRV_RFIDFILELIST	= PRV_RFID or 2;
	PRV_RFIDFILE		= PRV_RFID or 3;
	PRV_RFIDFILEDATA	= PRV_RFID or 4;
	PRV_CERTID_LIST		= PRV_RFID or 5;
	PRV_DGLIST			= PRV_RFID or 6;
	PRV_AUTHLIST		= PRV_RFID or 7;

	PRV_CARD			= $D0600000;
	PRV_CARDTYPE		= PRV_CARD or 1;
	PRV_CARDATR			= PRV_CARD or 2;
	PRV_CARDPOS			= PRV_CARD or 3;
	PRV_MEMORY_SIZE		= PRV_CARD or 4;
	PRV_MEMORY_BLOCK	= PRV_CARD or 5;
	PRV_CARDCAP			= PRV_CARD or 6;
	PRV_CHIPTYPE		= PRV_CARD or 7;

	PRV_COMMON			= $D0700000;
	PRV_PROCTIME		= PRV_COMMON or 1;
	PRV_PROCPERIOD		= PRV_COMMON or 2;
	PRV_WARNLIST		= PRV_COMMON or 3;
	PRV_TASK			= PRV_COMMON or 4;
	PRV_ODATA			= PRV_COMMON or 5;

	PRV_FINGER			= $D0800000;
	PRV_FINGER_TYPE		= PRV_FINGER or 1;
	PRV_NIST_QUALITY	= PRV_FINGER or 2;
	PRV_FINGER_DRYWET	= PRV_FINGER or 3;
	PRV_FINGER_FRACTION	= PRV_FINGER or 4;

// PR_VAR_ID_OCR_PARAMS - Variant IDs used in special OCR operations.

	PRV_OCRPARAMS		= PRV_OCR or $00090000;

	PRV_CHARHEIGHT		= PRV_OCRPARAMS or 1;
	PRV_SPACEWIDTH		= PRV_OCRPARAMS or 2;
	PRV_JUSTIFICATION	= PRV_OCRPARAMS or 3;
	PRV_SPACETYPE		= PRV_OCRPARAMS or 4;
	PRV_FONTTYPE		= PRV_OCRPARAMS or 5;

// PR_OCR_QUALITY_ALERT - OCR quality check flags.
	PR_OQA_CHARPOSITION		= 1;
	PR_OQA_CHARDISTANCE		= 2;
	PR_OQA_CHARSIZE			= 4;
	PR_OQA_CHARROTATION		= 8;
	PR_OQA_CONTRAST			= $10;
	PR_OQA_SPARE			= $20;
	PR_OQA_ERZ				= $40;
	PR_OQA_ROWPOSITION		= $100;
	PR_OQA_ROWDISTANCE		= $200;
	PR_OQA_ROWSIZE			= $400;
	PR_OQA_ROWROTATION		= $800;
	PR_OQA_SHAPE			= $1000;

// PR_VAR_ID_PA_WARNINGS - Variant ids for warnings of the Passive Authentication.

	PRV_PA_WARNLIST						= $D0590000;

	PRV_PA_WARN_UNKNOWN_DG				= PRV_PA_WARNLIST or 1;
	PRV_PA_WARN_DG_MISSING 				= PRV_PA_WARNLIST or 2;
	PRV_PA_WARN_DG_HASH_MISSING			= PRV_PA_WARNLIST or 3;
	PRV_PA_WARN_COM_FORMAT 				= PRV_PA_WARNLIST or 4;
	PRV_PA_WARN_HASH_CHECK 				= PRV_PA_WARNLIST or 5;
	PRV_PA_WARN_COM_MISSING				= PRV_PA_WARNLIST or 6;

	PRV_PA_WARN_DS_NOTFOUND				= PRV_PA_WARNLIST or 7;
	PRV_PA_WARN_DS_DATE_INVALID			= PRV_PA_WARNLIST or 8;
	PRV_PA_WARN_DS_DATE_RANGE			= PRV_PA_WARNLIST or 9;
	PRV_PA_WARN_DS_REVOKED				= PRV_PA_WARNLIST or 10;
	PRV_PA_WARN_DS_EXPIRED				= PRV_PA_WARNLIST or 11;
	PRV_PA_WARN_DS_WRONG_SIGNATURE		= PRV_PA_WARNLIST or 12;

	PRV_PA_WARN_AUTHKEYID_FORMAT		= PRV_PA_WARNLIST or 13;
	PRV_PA_WARN_AUTHKEYID_MISSING		= PRV_PA_WARNLIST or 14;

	PRV_PA_WARN_CS_NOTFOUND				= PRV_PA_WARNLIST or 15;
	PRV_PA_WARN_CS_EXPIRED				= PRV_PA_WARNLIST or 16;
	PRV_PA_WARN_CS_REVOKED				= PRV_PA_WARNLIST or 17;
	PRV_PA_WARN_CS_WRONG_SIGNATURE		= PRV_PA_WARNLIST or 18;

	PRV_PA_WARN_SOD_MISSING				= PRV_PA_WARNLIST or 19;
	PRV_PA_WARN_SOD_FORMAT 				= PRV_PA_WARNLIST or 20;
	PRV_PA_WARN_SOD_SIGNATURE_MISSING	= PRV_PA_WARNLIST or 21;
	PRV_PA_WARN_SOD_HASH_CHECK			= PRV_PA_WARNLIST or 22;
	PRV_PA_WARN_SOD_HASH_NOTFOUND		= PRV_PA_WARNLIST or 23;
	PRV_PA_WARN_SOD_WRONG_SIGNATURE		= PRV_PA_WARNLIST or 24;
	PRV_PA_WARN_SOD_SIGNEDDATA_MISSING	= PRV_PA_WARNLIST or 25;

	PRV_PA_WARN_CHAIN_DIFFERENT_ISSUER	= PRV_PA_WARNLIST or 26;

// PR_VAR_CHECKINGS - Detailed checking states.

	PRV_CHK_MISSING						= $D0080003;

	PRV_CHK_SELFCHK_OK					= $D0080010;
	PRV_CHK_SELFCHK_INVALID				= $D0080012;
	PRV_CHK_SELFCHK_FAILED				= $D0080013;

	PRV_CHK_FORMAT_OK					= $D0080020;
	PRV_CHK_FORMAT_INVALID				= $D0080023;

	PRV_CHK_DATE_OK						= $D0080030;
	PRV_CHK_DATE_INVALID				= $D0080032;
	PRV_CHK_DATE_EXPIRED				= $D0080033;

	PRV_CHK_REVOKED						= $D0080043;

// PR_FINGER_POSITION - Finger storage IDs.
	PR_FG_UNKNOWN		= 0;
	PR_FG_RIGHT_THUMB	= 1;
	PR_FG_RIGHT_INDEX	= 2;
	PR_FG_RIGHT_MIDDLE	= 3;
	PR_FG_RIGHT_RING	= 4;
	PR_FG_RIGHT_LITTLE	= 5;
	PR_FG_LEFT_THUMB	= 6;
	PR_FG_LEFT_INDEX	= 7;
	PR_FG_LEFT_MIDDLE	= 8;
	PR_FG_LEFT_RING		= 9;
	PR_FG_LEFT_LITTLE	= 10;

	PR_FG_PLAIN_RIGHT_THUMB		= 11;
	PR_FG_PLAIN_LEFT_THUMB		= 12;
	PR_FG_PLAIN_RIGHT_4FINGERS	= 13;
	PR_FG_PLAIN_LEFT_4FINGERS	= 14;
	PR_FG_PLAIN_THUMBS			= 15;

	PR_FG_BOTH_INDEXES			= 46;

// PR_FINGER_IMPRESSION_TYPE - The capturing mode of the finger capture process.
	PR_FG_SCAN_LIVE			= 0;
	PR_FG_SCAN_ROLLED		= 1;
	PR_FG_SCAN_ACCUMULATED	= $1000;

// PR_SELFTEST_ELEMENTS - Elements of the self test.
	PRV_SELFTESTLIST		= $57000000;
	PRV_ST_OVERALL_RESULT	= PRV_SELFTESTLIST + 1;
	PRV_ST_DEVICE_COMM		= PRV_SELFTESTLIST + 2;
	PRV_ST_RFID_COMM		= PRV_SELFTESTLIST + 3;
	PRV_ST_CALIBRATED		= PRV_SELFTESTLIST + 4;
	PRV_ST_SENSOR_COMM		= PRV_SELFTESTLIST + 5;
	PRV_ST_SENSOR_BUS		= PRV_SELFTESTLIST + 6;
	PRV_ST_LIGHT_SWITCH		= PRV_SELFTESTLIST + 7;
	PRV_ST_LIGHT_BLOWOUT	= PRV_SELFTESTLIST + 8;
	PRV_ST_NNC				= PRV_SELFTESTLIST + 9;
	PRV_ST_THERMOMETER		= PRV_SELFTESTLIST + 10;

// PR_SELFTEST_RESULT - Result of the self test.
	PR_ST_RESULT_OK			= 0;
	PR_ST_RESULT_SKIPPED	= 1;
	PR_ST_RESULT_UNKNOWN	= 2;
	PR_ST_RESULT_FAILED		= 3;

// PR_LICENSE - PR engine license types.
	PR_LICENSE_MRZOCR_BARCODEREADING = $F4;
	PR_LICENSE_MRZOCR_BARCODEREADINGL = $74;
	PR_LICENSE_MRZOCR_BARCODEREADINGF = $84;
	PR_LICENSE_VIZOCR_COUNTRY	= $10;
	PR_LICENSE_VIZOCR_REGION	= $11;
	PR_LICENSE_VIZOCR_WORLD		= $12;
	PR_LICENSE_VIZOCRAUTH_COUNTRY	= $13;
	PR_LICENSE_VIZOCRAUTH_REGION	= $14;
	PR_LICENSE_VIZOCRAUTH_WORLD	= $15;
	PR_LICENSE_PRSOFTWARE			= $A1;
	PR_LICENSE_PRAUTOFILL				= $A2;
	PR_LICENSE_ECARD			= $EC;
	PR_LICENSE_HOTEL_INTERFACE	= $FA;

//------------------------------------------------------------------------------
function PR_LIGHTS(light: Integer): string;
function PR_BC_TYPES(id: Integer): string;
//------------------------------------------------------------------------------
implementation
//------------------------------------------------------------------------------
function PR_LIGHTS(light: Integer): string;
begin
	case light of
		PR_LIGHT_OFF		: Result := 'Off';
		PR_LIGHT_WHITE		: Result := 'White';
		PR_LIGHT_INFRA		: Result := 'Infra';
		PR_LIGHT_UV			: Result := 'UV';
		PR_LIGHT_COAXIAL	: Result := 'Coaxial';
		PR_LIGHT_KINEGRAM	: Result := 'Kinegram';
		PR_LIGHT_PHOTO		: Result := 'Photo';
		PR_LIGHT_BLUE		: Result := 'Blue';
		PR_LIGHT_RED		: Result := 'Red';
		PR_LIGHT_CLEANUV	: Result := 'CleanUV';
		PR_LIGHT_CLEANOVD	: Result := 'CleanOVD';
	else Result := 'Unknown';
	end;
end;

function PR_BC_TYPES(id: Integer): string;
begin
	case id of
		PR_BCTYPE_EAN8		: Result := 'EAN8';
		PR_BCTYPE_EAN13		: Result := 'EAN13';
		PR_BCTYPE_CODE39	: Result := 'CODE39';
		PR_BCTYPE_CODE128	: Result := 'CODE128';
		PR_BCTYPE_PDF417	: Result := 'PDF417';
		PR_BCTYPE_INTER25	: Result := 'INTER25';
		PR_BCTYPE_DATAMATRIX	: Result := 'DATAMATRIX';
		PR_BCTYPE_QR		: Result := 'QR';
		PR_BCTYPE_AZTEC		: Result := 'AZTEC';
		PR_BCTYPE_UPU		: Result := 'UPU';
	else Result := 'Unknown';
	end;
end;
//------------------------------------------------------------------------------
end.
