Attribute VB_Name = "prdoctypes"
'-------------------------------------------------------------------------------
' PR DOCTYPES 2004-2021 (c) Adaptive Recognition
' 2021.06.03 v2.1.10
'-------------------------------------------------------------------------------

' Field Status Values

' PR_CHKERR
Public Const PR_CHKERR_OK = 0
Public Const PR_CHKERR_NO_CHECKSUM = 1

        'warnings
Public Const PR_CHKERR_WARNING = 100

Public Const PR_CHKERR_DATA_INTEGRITY = 101
Public Const PR_CHKERR_OCR_WARNING = 102

        'errors
Public Const PR_CHKERR_ERROR = 200

Public Const PR_CHKERR_ILLEGAL_CHAR = 201
Public Const PR_CHKERR_ILLEGAL_CHECKSUM = 202
Public Const PR_CHKERR_CHECKSUM = 203

'Document Code Values
' PR_DOCUMENT

Public Const PR_DOC_UNKNOWN = 0

Public Const PR_DOC_PASSPORT = 1
Public Const PR_DOC_IDCARD = 2
Public Const PR_DOC_IDCARD2 = 3
Public Const PR_DOC_VISA = 4
Public Const PR_DOC_IDFRA = 5
Public Const PR_DOC_IDCARDPRE = 6
Public Const PR_DOC_IDSVK1B = 7
Public Const PR_DOC_DLAAMVA = 8
Public Const PR_DOC_IDBEL3B = 9
Public Const PR_DOC_DLCHEB = 10
Public Const PR_DOC_IDCIV = 11
Public Const PR_DOC_FTCARD = 12
Public Const PR_DOC_BPIATA = 13
Public Const PR_DOC_IDCARDO2 = 14
Public Const PR_DOC_IDCARDO3 = 15
Public Const PR_DOC_IDLC = 16
Public Const PR_DOC_MAIL = 17
Public Const PR_DOC_EMRTD = 18
Public Const PR_DOC_EID = 19
Public Const PR_DOC_ESIGN = 20
Public Const PR_DOC_NFC = 21
Public Const PR_DOC_EDL = 22
Public Const PR_DOC_IDPRT = 23
Public Const PR_DOC_IDECU = 24
Public Const PR_DOC_IDMRZ = 25
Public Const PR_DOC_IDUSDOD = 26

        'hungarian module
Public Const PR_DOC_ACHUN = 101
Public Const PR_DOC_PNOCARD_HUN = 102
Public Const PR_DOC_DLHUNF = 103
Public Const PR_DOC_DLHUNB = 104
Public Const PR_DOC_IDHUNF = 105
Public Const PR_DOC_IDHUNB = 106
Public Const PR_DOC_IDHUNO = 107
Public Const PR_DOC_DLHEUF = 108
Public Const PR_DOC_DLHEUB = 109
Public Const PR_DOC_PPHUN = 110
Public Const PR_DOC_E111HUNB = 111
Public Const PR_DOC_HICHUNO = 112
Public Const PR_DOC_E111HUNB2 = 113
Public Const PR_DOC_HICHUNO2 = 114
Public Const PR_DOC_HICHUNO3 = 115
Public Const PR_DOC_PPHUN1 = 116
Public Const PR_DOC_PNOCARD_HUN1 = 117
Public Const PR_DOC_PPHUN2 = 118
Public Const PR_DOC_IDHUN2F = 119
Public Const PR_DOC_IDHUN2B = 120
Public Const PR_DOC_PNOCARD_HUN2 = 121
Public Const PR_DOC_DLHUN2F = 122
Public Const PR_DOC_DLHUN2B = 123

        'spanish module
Public Const PR_DOC_IDESPF = 201
Public Const PR_DOC_IDESPB = 202
Public Const PR_DOC_IDESPBO = 203
Public Const PR_DOC_IDESPFORF1 = 204
Public Const PR_DOC_IDESPFORB1 = 205
Public Const PR_DOC_IDESPFORF2 = 206
Public Const PR_DOC_IDESPFORB2 = 207
Public Const PR_DOC_IDESPF2 = 208
Public Const PR_DOC_IDESPB2 = 209
Public Const PR_DOC_DLESPF = 210

        'hungarian cheque module
Public Const PR_DOC_POSTAL_CHEQUE = 301

        'european health insurance cards
Public Const PR_DOC_E111_5RF = 401
Public Const PR_DOC_E111_4RF = 402

        'passports
Public Const PR_DOC_PPIND = 501
Public Const PR_DOC_PPSGP_P = 502
Public Const PR_DOC_PPSGP_PA = 503
Public Const PR_DOC_PPSGP_BIO = 504
Public Const PR_DOC_IDSGPF1 = 505

        'albanian module
Public Const PR_DOC_ALB_DLF = 601

        'mexican credential
Public Const PR_DOC_MEX_CREDF = 701
Public Const PR_DOC_MEX_CREDB = 702
Public Const PR_DOC_MEX_CRED1F = 703
Public Const PR_DOC_MEX_CRED2F = 704
Public Const PR_DOC_MEX_CRED0F = 705

        'Hong Kong and Chinese cards
Public Const PR_DOC_IDHKG = 801
Public Const PR_DOC_IDCHN = 802
Public Const PR_DOC_HKMP = 803
Public Const PR_DOC_HKIDC = 804
Public Const PR_DOC_IDHKGO = 805
Public Const PR_DOC_CHNKE = 806
Public Const PR_DOC_CHNOWP = 807
Public Const PR_DOC_CHNHVP = 808
Public Const PR_DOC_MOADC = 809
Public Const PR_DOC_CHNPP = 810
Public Const PR_DOC_MCSIDC = 811
Public Const PR_DOC_CHNEEP = 812
Public Const PR_DOC_CHNPP1 = 813
Public Const PR_DOC_HKGMTP1 = 814
Public Const PR_DOC_HKGMTP2 = 815
Public Const PR_DOC_CHNPP0 = 816
Public Const PR_DOC_CHNPS = 817
Public Const PR_DOC_CHNPT = 818
Public Const PR_DOC_MCSIDCF = 819
Public Const PR_DOC_CHNHRP = 820
Public Const PR_DOC_IDMACF821 = 821
Public Const PR_DOC_IDMACB822 = 822

        'South African module
Public Const PR_DOC_IDRSA1 = 901
Public Const PR_DOC_IDRSA2 = 902

        'Dutch driving licenses
Public Const PR_DOC_DLNLDF = 1001
Public Const PR_DOC_DLNLDB = 1002
Public Const PR_DOC_DLNLDO = 1003
Public Const PR_DOC_IDNLDF = 1004
Public Const PR_DOC_IDNLDB = 1005
Public Const PR_DOC_NDLNLDF = 1006
Public Const PR_DOC_NDLNLDB = 1007
Public Const PR_DOC_DLNLDO2 = 1008

        'Australian driving licenses
Public Const PR_DOC_DLAUSWAF = 1101
Public Const PR_DOC_DLAUSNSW1 = 1102
Public Const PR_DOC_DLAUSNSW2 = 1103
Public Const PR_DOC_DLAUSVF = 1104
Public Const PR_DOC_PAAUSWAF = 1105
Public Const PR_DOC_DLAUSVPF = 1106
Public Const PR_DOC_DLAUSV1F = 1107
Public Const PR_DOC_DLAUSV1PF = 1108
Public Const PR_DOC_PCAUSNSW = 1109
Public Const PR_DOC_DLAUSNT1 = 1110
Public Const PR_DOC_DLAUSNT2 = 1111
Public Const PR_DOC_DLAUSNT1P = 1112
Public Const PR_DOC_DLAUSSA = 1113
Public Const PR_DOC_PAAUSSA = 1114
Public Const PR_DOC_PAAUSQL = 1115
Public Const PR_DOC_DLAUSQL1 = 1116
Public Const PR_DOC_DLAUSQL2 = 1117
Public Const PR_DOC_DLAUSQL3 = 1118
Public Const PR_DOC_DLAUSWA1F = 1119
Public Const PR_DOC_DLAUSWA1PF = 1120
Public Const PR_DOC_PAAUSVF = 1121
Public Const PR_DOC_KPAUS = 1122
Public Const PR_DOC_DLAUSACTF = 1123
Public Const PR_DOC_PAAUSACTF = 1124
Public Const PR_DOC_DLAUSQL4 = 1125
Public Const PR_DOC_PAAUSQL2 = 1126
Public Const PR_DOC_PAAUSSA1 = 1161
Public Const PR_DOC_DLAUSSA1 = 1171
Public Const PR_DOC_DLAUSWA2F = 1173
Public Const PR_DOC_DLAUSWA2PF = 1175

        'Poland
Public Const PR_DOC_POLIDF1 = 1201
Public Const PR_DOC_POLIDB1 = 1202
Public Const PR_DOC_POLDLF1 = 1203
Public Const PR_DOC_POLDLFO = 1204
Public Const PR_DOC_POLSTCD = 1205

        'Slovak documents
Public Const PR_DOC_SLOIDOF1 = 1301
Public Const PR_DOC_SLOIDOB1 = 1302
Public Const PR_DOC_SLOIDF1 = 1303
Public Const PR_DOC_SLOIDFO = 1304

        'Croatian documents
Public Const PR_DOC_HRVIDF1 = 1401
Public Const PR_DOC_HRVIDB1 = 1402
Public Const PR_DOC_HRVIDF2 = 1403
Public Const PR_DOC_HRVIDB2 = 1404

'Saudi Arabia
Public Const PR_DOC_DLSAU = 1501
Public Const PR_DOC_RPSAU = 1502
Public Const PR_DOC_LCUAE = 1503
Public Const PR_DOC_RPUAE = 1504
Public Const PR_DOC_RPSAU2 = 1505

'United Kingdom
Public Const PR_DOC_DLGBR1F = 1601
Public Const PR_DOC_DLGBR2F = 1602
Public Const PR_DOC_DLPGBR1F = 1603

        'Other documents
Public Const PR_DOC_CZEPPD = 2001
Public Const PR_DOC_GERPPD = 2002
Public Const PR_DOC_UKPP = 2003
Public Const PR_DOC_NLDPP = 2004
Public Const PR_DOC_NLDPPD = 2005
Public Const PR_DOC_PORPP = 2006
Public Const PR_DOC_SWEPPE = 2007
Public Const PR_DOC_SWEPP = 2008
Public Const PR_DOC_UKTD = 2009
Public Const PR_DOC_FINPPS = 2010
Public Const PR_DOC_FINPP = 2011
Public Const PR_DOC_FINPPD = 2012
Public Const PR_DOC_FRAPP = 2013
Public Const PR_DOC_FRAPPO = 2014
Public Const PR_DOC_RUSPPS = 2015
Public Const PR_DOC_RUSPPD = 2016
Public Const PR_DOC_TWNPP = 2017
Public Const PR_DOC_PAKPP = 2018
Public Const PR_DOC_AUSPP = 2019
Public Const PR_DOC_CZEPP0 = 2020
Public Const PR_DOC_DNKPP = 2021
Public Const PR_DOC_ITAPP = 2022
Public Const PR_DOC_JPNPP1 = 2023
Public Const PR_DOC_KORPP = 2024
Public Const PR_DOC_NORPP1 = 2026
Public Const PR_DOC_POLPPS = 2027
Public Const PR_DOC_USAPP = 2028
Public Const PR_DOC_AUTPP = 2029
Public Const PR_DOC_BELPP = 2030
Public Const PR_DOC_SVKPPD = 2031
Public Const PR_DOC_GERPP = 2032
Public Const PR_DOC_BGRPP = 2033
Public Const PR_DOC_ESTPP = 2034
Public Const PR_DOC_SVNPP = 2035
Public Const PR_DOC_ESPPP = 2036
Public Const PR_DOC_IRLPP = 2037
Public Const PR_DOC_GRCPP = 2038
Public Const PR_DOC_LTUPP = 2039
Public Const PR_DOC_LUXPP = 2040
Public Const PR_DOC_LVAPP = 2041
Public Const PR_DOC_MLTPP1 = 2042
Public Const PR_DOC_ROUPP1 = 2043
Public Const PR_DOC_POLPP1 = 2044
Public Const PR_DOC_RUSPP = 2045
Public Const PR_DOC_CZEPPA = 2047
Public Const PR_DOC_ARHPP = 2049
Public Const PR_DOC_EGYPP = 2050
Public Const PR_DOC_MYSPP = 2051
Public Const PR_DOC_OMNPP = 2052
Public Const PR_DOC_QATPP1 = 2053
Public Const PR_DOC_SAUPPP = 2054
Public Const PR_DOC_ANDPP = 2055
Public Const PR_DOC_ALBPP = 2056
Public Const PR_DOC_BIHPPD = 2057
Public Const PR_DOC_BLRPP = 2058
Public Const PR_DOC_CHEPP1 = 2059
Public Const PR_DOC_CYPPP1 = 2060
Public Const PR_DOC_BIHPPS = 2061
Public Const PR_DOC_DNKPPFI = 2062
Public Const PR_DOC_HRVPPS = 2063
Public Const PR_DOC_DNKPPT = 2064
Public Const PR_DOC_ISLPP1 = 2065
Public Const PR_DOC_LVAPPS = 2066
Public Const PR_DOC_MDVPP = 2067
Public Const PR_DOC_MKDPP = 2068
Public Const PR_DOC_MLAPP = 2069
Public Const PR_DOC_MKDPPS = 2070
Public Const PR_DOC_POLPPD = 2071
Public Const PR_DOC_MNEPP = 2072
Public Const PR_DOC_MNEPPD = 2073
Public Const PR_DOC_SMRPP1 = 2074
Public Const PR_DOC_SRBPPD = 2075
Public Const PR_DOC_SRBPP = 2076
Public Const PR_DOC_SVKPPS = 2077
Public Const PR_DOC_THAPP = 2078
Public Const PR_DOC_TWNPP0 = 2079
Public Const PR_DOC_ZAFPP = 2080
Public Const PR_DOC_ARGPP = 2081
Public Const PR_DOC_BRAPP1 = 2082
Public Const PR_DOC_VNMPP = 2083
Public Const PR_DOC_CANPP = 2084
Public Const PR_DOC_UKRPP = 2085
Public Const PR_DOC_GEOPP1 = 2086
Public Const PR_DOC_IDNPP = 2087
Public Const PR_DOC_PRYPP = 2088
Public Const PR_DOC_ISRPP = 2089
Public Const PR_DOC_IRQPPS = 2090
Public Const PR_DOC_PHLPP = 2091
Public Const PR_DOC_NZLPP = 2092
Public Const PR_DOC_NGAPPD = 2093
Public Const PR_DOC_IRNPPD = 2094
Public Const PR_DOC_KENPP = 2095
Public Const PR_DOC_KORPPS = 2096
Public Const PR_DOC_MEXPP = 2097
Public Const PR_DOC_LBNPP = 2098
Public Const PR_DOC_BGRPP1 = 2099
Public Const PR_DOC_CZEPP1 = 2100
Public Const PR_DOC_ESTPP1 = 2101
Public Const PR_DOC_GERVS = 2102
Public Const PR_DOC_TUNPPDS = 2103
Public Const PR_DOC_TUNPP = 2104
Public Const PR_DOC_MARPP = 2106
Public Const PR_DOC_CHNPP2 = 2107
Public Const PR_DOC_CHNPP3 = 2108
Public Const PR_DOC_TURPP = 2109
Public Const PR_DOC_PHLPP1 = 2110
Public Const PR_DOC_ZAFPD = 2111
Public Const PR_DOC_ZAFPP1 = 2112
Public Const PR_DOC_ZAFPO = 2114
Public Const PR_DOC_ZAFPE = 2115
Public Const PR_DOC_ZAFPT1 = 2116
Public Const PR_DOC_ZAFPC = 2119
Public Const PR_DOC_ZAFPT = 2120
Public Const PR_DOC_BELVS = 2122
Public Const PR_DOC_NLDVS = 2125
Public Const PR_DOC_INDPP = 2126
Public Const PR_DOC_ALBPD = 2127
Public Const PR_DOC_ALBPS = 2128
Public Const PR_DOC_BFAPD = 2129
Public Const PR_DOC_BFAPP = 2130
Public Const PR_DOC_BFAPP1 = 2131
Public Const PR_DOC_BFAPS = 2132
Public Const PR_DOC_CIVPP = 2133
Public Const PR_DOC_CODPD = 2134
Public Const PR_DOC_CODPP = 2135
Public Const PR_DOC_CODPS = 2136
Public Const PR_DOC_CODPP1 = 2137
Public Const PR_DOC_GMBPP = 2138
Public Const PR_DOC_LBRPD = 2139
Public Const PR_DOC_LBRPP = 2140
Public Const PR_DOC_LBRPS = 2141
Public Const PR_DOC_NLDPP1 = 2142
Public Const PR_DOC_PANPP = 2143
Public Const PR_DOC_PEPP = 2144
Public Const PR_DOC_PEPP1 = 2145
Public Const PR_DOC_SMRPP2 = 2148
Public Const PR_DOC_HRVPD2 = 2149
Public Const PR_DOC_HRVPP1 = 2150
Public Const PR_DOC_INDPP1 = 2151
Public Const PR_DOC_LBRPO = 2152
Public Const PR_DOC_IRNPP1 = 2153
Public Const PR_DOC_FRAVS = 2154
Public Const PR_DOC_GHAPP = 2155
Public Const PR_DOC_HKGPP1 = 2156
Public Const PR_DOC_PAKPP1 = 2158
Public Const PR_DOC_RUSPP1 = 2159
Public Const PR_DOC_LKAPP = 2160
Public Const PR_DOC_LKAPP1 = 2161
Public Const PR_DOC_CHNPP4 = 2162
Public Const PR_DOC_THAPP1 = 2164
Public Const PR_DOC_IRNPS = 2165
Public Const PR_DOC_IRNPP = 2166
Public Const PR_DOC_NLDPP2 = 2167
Public Const PR_DOC_AUTVS = 2168
Public Const PR_DOC_CZEVS = 2169
Public Const PR_DOC_ESPVS = 2170
Public Const PR_DOC_FINVS = 2171
Public Const PR_DOC_FRAVS1 = 2172
Public Const PR_DOC_GBRVS = 2173
Public Const PR_DOC_GRCVS = 2174
Public Const PR_DOC_HUNVS = 2175
Public Const PR_DOC_ITAVS = 2176
Public Const PR_DOC_LTUVS = 2177
Public Const PR_DOC_SWEVS = 2178
Public Const PR_DOC_MLTVS = 2179
Public Const PR_DOC_NORVS = 2180
Public Const PR_DOC_POLVS = 2181
Public Const PR_DOC_SVKVS = 2182
Public Const PR_DOC_IRNPD = 2184
Public Const PR_DOC_LIEPD1 = 2445
Public Const PR_DOC_LIEPP = 2447
Public Const PR_DOC_PHLPP2 = 2567
Public Const PR_DOC_SVNPP1 = 2625
Public Const PR_DOC_SYRPP = 2699
Public Const PR_DOC_SURPP = 2700
Public Const PR_DOC_LIEPP1 = 2701
Public Const PR_DOC_IDROUF2706 = 2706
Public Const PR_DOC_IDCZEF2707 = 2707

Public Const PR_DOC_IDDEUF2710 = 2710
Public Const PR_DOC_IDDEUF2714 = 2714
Public Const PR_DOC_DLAUTF = 2716
Public Const PR_DOC_IDFRAF2718 = 2718
Public Const PR_DOC_IDFRAB2719 = 2719
Public Const PR_DOC_IDCZEF2759 = 2759
Public Const PR_DOC_DLTHAF2805 = 2805
Public Const PR_DOC_DLTHAF2806 = 2806
Public Const PR_DOC_DLTHAF2807 = 2807
Public Const PR_DOC_IDCZEF2874 = 2874
Public Const PR_DOC_IDDEUF2879 = 2879

Public Const PR_DOC_IDNLDF3058 = 3058
Public Const PR_DOC_RPNLDF3059 = 3059
Public Const PR_DOC_IDROUF3088 = 3088
Public Const PR_DOC_IDNLDB3180 = 3180
Public Const PR_DOC_RPNLDF3182 = 3182
Public Const PR_DOC_DLUSAFLF3200 = 3200
Public Const PR_DOC_DLUSACAF3201 = 3201
Public Const PR_DOC_DLUSAORF3202 = 3202
Public Const PR_DOC_DLUSAFLF3203 = 3203
Public Const PR_DOC_RPDEUF3204 = 3204
Public Const PR_DOC_PPOTHA3206 = 3206
Public Const PR_DOC_RPFRAF3207 = 3207
Public Const PR_DOC_RPFRAB3208 = 3208

Public Const PR_DOC_DLSAUF3241 = 3241
Public Const PR_DOC_IDIDNF3254 = 3254
Public Const PR_DOC_IDIDNF3255 = 3255
Public Const PR_DOC_IDDEUB3266 = 3266
Public Const PR_DOC_PPNLD3289 = 3289
Public Const PR_DOC_IDMYSF3300 = 3300
Public Const PR_DOC_DLITAF3358 = 3358
Public Const PR_DOC_IDSGPF3362 = 3362
Public Const PR_DOC_DLSGPF3363 = 3363
Public Const PR_DOC_IDSGPF3364 = 3364
Public Const PR_DOC_IDMYSF3367 = 3367
Public Const PR_DOC_IDTHAF3369 = 3369
Public Const PR_DOC_IDSAUB3371 = 3371
Public Const PR_DOC_IDSAUF3377 = 3377
Public Const PR_DOC_IDDEUF3457 = 3457
Public Const PR_DOC_DLIDNF3462 = 3462
Public Const PR_DOC_DLITAB3463 = 3463
Public Const PR_DOC_DLITAF3499 = 3499
Public Const PR_DOC_DLITAB3500 = 3500
Public Const PR_DOC_DLCZEF3501 = 3501
Public Const PR_DOC_IDSGPF3536 = 3536
Public Const PR_DOC_IDSGPF3537 = 3537
Public Const PR_DOC_IDSGPF3538 = 3538
Public Const PR_DOC_IDSGPF3539 = 3539
Public Const PR_DOC_SPSGPF3540 = 3540
Public Const PR_DOC_EPSGPF3541 = 3541
Public Const PR_DOC_WPSGPF3542 = 3542
Public Const PR_DOC_IDSGPF3543 = 3543

'Field Code Values
' PR_DOCFIELD

Public Const PR_DF_UNKNOWN = 0

Public Const PR_DF_BLOCK = 1000
Public Const PR_DF_PARTS = 100

Public Const PR_DFE_COMPOSITE1 = 1
Public Const PR_DFE_COMPOSITE2 = 2
Public Const PR_DFE_COMPOSITE3 = 3
Public Const PR_DFE_COMPOSITE4 = 4
Public Const PR_DFE_COMPOSITE5 = 5

Public Const PR_DFE_NAME = 101
Public Const PR_DFE_GIVENNAME = 102
Public Const PR_DFE_SURNAME = 103
Public Const PR_DFE_SURNAME2 = 104
Public Const PR_DFE_MIDDLENAME = 105
Public Const PR_DFE_MAIDEN_NAME = 107
Public Const PR_DFE_MAIDEN_GIVENNAME = 108
Public Const PR_DFE_MAIDEN_SURNAME = 109

Public Const PR_DFE_BIRTH_DATE = 113
Public Const PR_DFE_BIRTH_PLACE = 114
Public Const PR_DFE_BIRTH_COUNTRY = 115
Public Const PR_DFE_MOTHER_NAME = 116
Public Const PR_DFE_MOTHER_GIVENNAME = 117
Public Const PR_DFE_MOTHER_SURNAME = 118

Public Const PR_DFE_NATIONALITY = 119
Public Const PR_DFE_SEX = 120
Public Const PR_DFE_BIRTH_PROVINCE = 121
Public Const PR_DFE_PARENTS_NAME = 122
Public Const PR_DFE_FATHER_NAME = 123
Public Const PR_DFE_MARITAL_STATUS = 124
Public Const PR_DFE_FATHER_GIVENNAME = 125
Public Const PR_DFE_FATHER_SURNAME = 126

Public Const PR_DFE_DOCUMENT_NUMBER = 130
Public Const PR_DFE_TYPE = 131
Public Const PR_DFE_ISSUE_COUNTRY = 132
Public Const PR_DFE_ISSUE_PLACE = 133
Public Const PR_DFE_ISSUE_STATE = 134
Public Const PR_DFE_ISSUE_DATE = 135
Public Const PR_DFE_EXPIRY_DATE = 136
Public Const PR_DFE_ISSUE_ORG = 137
Public Const PR_DFE_PROVISIONAL_END_DATE = 138

Public Const PR_DFE_PERSONAL_NUMBER = 140
Public Const PR_DFE_HEALTH_INS_NUMBER = 141
Public Const PR_DFE_REGISTRATION_NUMBER = 142
Public Const PR_DFE_DUF_NUMBER = 143
Public Const PR_DFE_CAN = 144

Public Const PR_DFE_DOCTYPE = 149
Public Const PR_DFE_DOCPAGE = 150
Public Const PR_DFE_DTDISC = 151

Public Const PR_DFE_PERSONAL_DATA1 = 160
Public Const PR_DFE_PERSONAL_DATA2 = 161

Public Const PR_DFE_ADDRESS = 200
Public Const PR_DFE_ADDR_ZIP = 201
Public Const PR_DFE_ADDR_CITY = 202
Public Const PR_DFE_ADDR_STREET = 203
Public Const PR_DFE_ADDR_HOUSE = 204
Public Const PR_DFE_ADDR_FLAT = 205
Public Const PR_DFE_ADDR_DATE = 206
Public Const PR_DFE_ADDR_STATE = 209
Public Const PR_DFE_ADDR_PROVINCE = 210
Public Const PR_DFE_ADDR_MUNICIPALITY = 212

Public Const PR_DFE_TEMPADDRESS = 220
Public Const PR_DFE_TEMPADDR_ZIP = 221
Public Const PR_DFE_TEMPADDR_CITY = 222
Public Const PR_DFE_TEMPADDR_STREET = 223
Public Const PR_DFE_TEMPADDR_HOUSE = 224
Public Const PR_DFE_TEMPADDR_FLAT = 225
Public Const PR_DFE_TEMPADDR_DATE = 226
Public Const PR_DFE_TEMPADDR_DATEEND = 227
Public Const PR_DFE_TEMPADDR_STATE = 229
Public Const PR_DFE_TEMPADDR_PROVINCE = 230
Public Const PR_DFE_TEMPADDR_MUNICIPALITY = 232

Public Const PR_DFE_VALID_AREA = 240
Public Const PR_DFE_START_OF_VALIDITY = 241
Public Const PR_DFE_NUMBER_OF_ENTRIES = 242
Public Const PR_DFE_DURATION_OF_STAY = 243

Public Const PR_DFE_REFERENCE = 300
Public Const PR_DFE_AMOUNT = 301
Public Const PR_DFE_BANK_ACCOUNT = 302
Public Const PR_DFE_POSTAL_REFERENCE = 303
Public Const PR_DFE_TRANSACTION_CODE = 304
Public Const PR_DFE_SUPPLIER = 305
Public Const PR_DFE_OUTPUT_CODE = 306

Public Const PR_DFE_FROMADDR = 320
Public Const PR_DFE_DESTADDR = 321
Public Const PR_DFE_FLIGHTNO = 322
Public Const PR_DFE_COMPARTMENT = 323
Public Const PR_DFE_SEATNO = 324
Public Const PR_DFE_CHECKINSEQ = 325

Public Const PR_DFE_FACE = 400
Public Const PR_DFE_SIGNATURE = 420
Public Const PR_DFE_FINGERPRINT = 430
Public Const PR_DFE_IRIS = 440
Public Const PR_DFE_BIODATA = 450

Public Const PR_DFE_HEIGHT = 490
Public Const PR_DFE_WEIGHT = 491
Public Const PR_DFE_EYECOLOR = 492
Public Const PR_DFE_HAIRCOLOR = 493

Public Const PR_DFE_AUTHENTICITY = 500
Public Const PR_DFE_AUTHENTICITY1 = 501
Public Const PR_DFE_AUTHENTICITY2 = 502
Public Const PR_DFE_AUTHENTICITY3 = 503
Public Const PR_DFE_AUTHENTICITY4 = 504
Public Const PR_DFE_AUTHENTICITY5 = 505

Public Const PR_DFE_TELEPHONE = 600
Public Const PR_DFE_PROFESSION = 601
Public Const PR_DFE_TITLE = 602
Public Const PR_DFE_PERSONAL_SUMMARY = 603
Public Const PR_DFE_PROOF_OF_CITIZENSHIP = 604
Public Const PR_DFE_OTHER_TD_NUMBERS = 605
Public Const PR_DFE_CUSTODY_INFORMATION = 606
Public Const PR_DFE_OTHER_NAME = 607
Public Const PR_DFE_OTHER_PEOPLE = 608
Public Const PR_DFE_OBSERVATIONS = 609
Public Const PR_DFE_TAX = 610
Public Const PR_DFE_FRONT_IMAGE = 611
Public Const PR_DFE_REAR_IMAGE = 612
Public Const PR_DFE_PERSONALIZATION_DATE = 613
Public Const PR_DFE_PERSONALIZATION_SYSTEM = 614
Public Const PR_DFE_ORGAN_DONOR = 615
Public Const PR_DFE_REMARKS = 616
Public Const PR_DFE_BLOODTYPE = 617
Public Const PR_DFE_RANK = 618
Public Const PR_DFE_SERVICE_BRANCH = 619

Public Const PR_DFE_CAR = 620
Public Const PR_DFE_CHR = 621

Public Const PR_DFE_LOWLEVEL = 997
Public Const PR_DFE_FORMAT_CHECK = 998
Public Const PR_DFE_DOCUMENT_DESCRIPTOR = 999

        'Machine Readable Zone (MRZ)
Public Const PR_DF_MRZ_FIELDS = 1000

Public Const PR_DF_MRZ1 = PR_DF_MRZ_FIELDS + PR_DFE_COMPOSITE1
Public Const PR_DF_MRZ2 = PR_DF_MRZ_FIELDS + PR_DFE_COMPOSITE2
Public Const PR_DF_MRZ3 = PR_DF_MRZ_FIELDS + PR_DFE_COMPOSITE3

Public Const PR_DF_MRZ_NAME = PR_DF_MRZ_FIELDS + PR_DFE_NAME
Public Const PR_DF_MRZ_GIVENNAME = PR_DF_MRZ_FIELDS + PR_DFE_GIVENNAME
Public Const PR_DF_MRZ_SURNAME = PR_DF_MRZ_FIELDS + PR_DFE_SURNAME
Public Const PR_DF_MRZ_BIRTH_DATE = PR_DF_MRZ_FIELDS + PR_DFE_BIRTH_DATE
Public Const PR_DF_MRZ_NATIONALITY = PR_DF_MRZ_FIELDS + PR_DFE_NATIONALITY
Public Const PR_DF_MRZ_SEX = PR_DF_MRZ_FIELDS + PR_DFE_SEX

Public Const PR_DF_MRZ_DOCUMENT_NUMBER = PR_DF_MRZ_FIELDS + PR_DFE_DOCUMENT_NUMBER
Public Const PR_DF_MRZ_TYPE = PR_DF_MRZ_FIELDS + PR_DFE_TYPE
Public Const PR_DF_MRZ_ISSUE_COUNTRY = PR_DF_MRZ_FIELDS + PR_DFE_ISSUE_COUNTRY
Public Const PR_DF_MRZ_ISSUE_STATE = PR_DF_MRZ_FIELDS + PR_DFE_ISSUE_STATE
Public Const PR_DF_MRZ_EXPIRY_DATE = PR_DF_MRZ_FIELDS + PR_DFE_EXPIRY_DATE

Public Const PR_DF_MRZ_PERSONAL_DATA = PR_DF_MRZ_FIELDS + PR_DFE_PERSONAL_DATA1
Public Const PR_DF_MRZ_PERSONAL_DATA2 = PR_DF_MRZ_FIELDS + PR_DFE_PERSONAL_DATA2

Public Const PR_DF_MRZ_REFERENCE = PR_DF_MRZ_FIELDS + PR_DFE_REFERENCE
Public Const PR_DF_MRZ_AMOUNT = PR_DF_MRZ_FIELDS + PR_DFE_AMOUNT
Public Const PR_DF_MRZ_BANK_ACCOUNT = PR_DF_MRZ_FIELDS + PR_DFE_BANK_ACCOUNT
Public Const PR_DF_MRZ_POSTAL_REFERENCE = PR_DF_MRZ_FIELDS + PR_DFE_POSTAL_REFERENCE
Public Const PR_DF_MRZ_TRANSACTION_CODE = PR_DF_MRZ_FIELDS + PR_DFE_TRANSACTION_CODE
Public Const PR_DF_MRZ_SUPPLIER = PR_DF_MRZ_FIELDS + PR_DFE_SUPPLIER
Public Const PR_DF_MRZ_OUTPUT_CODE = PR_DF_MRZ_FIELDS + PR_DFE_OUTPUT_CODE

Public Const PR_DF_MRZ_AUTH_B900 = 1551

        'Visual Inspection Zone (VIZ)
Public Const PR_DF_VIZ_FIELDS = 2000

Public Const PR_DF_VIZ1 = PR_DF_VIZ_FIELDS + PR_DFE_COMPOSITE1
Public Const PR_DF_VIZ2 = PR_DF_VIZ_FIELDS + PR_DFE_COMPOSITE2
Public Const PR_DF_VIZ3 = PR_DF_VIZ_FIELDS + PR_DFE_COMPOSITE3

Public Const PR_DF_VIZ_NAME = PR_DF_VIZ_FIELDS + PR_DFE_NAME
Public Const PR_DF_VIZ_GIVENNAME = PR_DF_VIZ_FIELDS + PR_DFE_GIVENNAME
Public Const PR_DF_VIZ_SURNAME = PR_DF_VIZ_FIELDS + PR_DFE_SURNAME
Public Const PR_DF_VIZ_SURNAME2 = PR_DF_VIZ_FIELDS + PR_DFE_SURNAME2
Public Const PR_DF_VIZ_MIDDLENAME = PR_DF_VIZ_FIELDS + PR_DFE_MIDDLENAME
Public Const PR_DF_VIZ_MAIDEN_NAME = PR_DF_VIZ_FIELDS + PR_DFE_MAIDEN_NAME

Public Const PR_DF_VIZ_BIRTH_DATE = PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_DATE
Public Const PR_DF_VIZ_BIRTH_PLACE = PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_PLACE
Public Const PR_DF_VIZ_BIRTH_COUNTRY = PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_COUNTRY
Public Const PR_DF_VIZ_MOTHER_NAME = PR_DF_VIZ_FIELDS + PR_DFE_MOTHER_NAME
Public Const PR_DF_VIZ_NATIONALITY = PR_DF_VIZ_FIELDS + PR_DFE_NATIONALITY
Public Const PR_DF_VIZ_SEX = PR_DF_VIZ_FIELDS + PR_DFE_SEX
Public Const PR_DF_VIZ_BIRTH_PROVINCE = PR_DF_VIZ_FIELDS + PR_DFE_BIRTH_PROVINCE
Public Const PR_DF_VIZ_PARENTS_NAME = PR_DF_VIZ_FIELDS + PR_DFE_PARENTS_NAME

Public Const PR_DF_VIZ_DOCUMENT_NUMBER = PR_DF_VIZ_FIELDS + PR_DFE_DOCUMENT_NUMBER
Public Const PR_DF_VIZ_TYPE = PR_DF_VIZ_FIELDS + PR_DFE_TYPE
Public Const PR_DF_VIZ_ISSUE_COUNTRY = PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_COUNTRY
Public Const PR_DF_VIZ_ISSUE_PLACE = PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_PLACE
Public Const PR_DF_VIZ_ISSUE_DATE = PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_DATE
Public Const PR_DF_VIZ_EXPIRY_DATE = PR_DF_VIZ_FIELDS + PR_DFE_EXPIRY_DATE
Public Const PR_DF_VIZ_ISSUE_ORG = PR_DF_VIZ_FIELDS + PR_DFE_ISSUE_ORG

Public Const PR_DF_VIZ_PERSONAL_NUMBER = PR_DF_VIZ_FIELDS + PR_DFE_PERSONAL_NUMBER
Public Const PR_DF_VIZ_HEALTH_INS_NUMBER = PR_DF_VIZ_FIELDS + PR_DFE_HEALTH_INS_NUMBER

Public Const PR_DF_VIZ_ADDRESS = PR_DF_VIZ_FIELDS + PR_DFE_ADDRESS
Public Const PR_DF_VIZ_ADDR_ZIP = PR_DF_VIZ_FIELDS + PR_DFE_ADDR_ZIP
Public Const PR_DF_VIZ_ADDR_CITY = PR_DF_VIZ_FIELDS + PR_DFE_ADDR_CITY
Public Const PR_DF_VIZ_ADDR_STREET = PR_DF_VIZ_FIELDS + PR_DFE_ADDR_STREET
Public Const PR_DF_VIZ_ADDR_HOUSE = PR_DF_VIZ_FIELDS + PR_DFE_ADDR_HOUSE
Public Const PR_DF_VIZ_ADDR_FLAT = PR_DF_VIZ_FIELDS + PR_DFE_ADDR_FLAT
Public Const PR_DF_VIZ_ADDR_DATE = PR_DF_VIZ_FIELDS + PR_DFE_ADDR_DATE
Public Const PR_DF_VIZ_ADDR_PROVINCE = PR_DF_VIZ_FIELDS + PR_DFE_ADDR_PROVINCE

Public Const PR_DF_VIZ_TEMPADDRESS = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDRESS
Public Const PR_DF_VIZ_TEMPADDR_ZIP = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_ZIP
Public Const PR_DF_VIZ_TEMPADDR_CITY = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_CITY
Public Const PR_DF_VIZ_TEMPADDR_STREET = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_STREET
Public Const PR_DF_VIZ_TEMPADDR_HOUSE = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_HOUSE
Public Const PR_DF_VIZ_TEMPADDR_FLAT = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_FLAT
Public Const PR_DF_VIZ_TEMPADDR_DATE = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_DATE
Public Const PR_DF_VIZ_TEMPADDR_DATEEND = PR_DF_VIZ_FIELDS + PR_DFE_TEMPADDR_DATEEND

Public Const PR_DF_VIZ_REFERENCE = PR_DF_VIZ_FIELDS + PR_DFE_REFERENCE
Public Const PR_DF_VIZ_AMOUNT = PR_DF_VIZ_FIELDS + PR_DFE_AMOUNT
'Public Const PR_DF_VIZ_BANK_ACCOUNT = PR_DF_VIZ_FIELDS + PR_DFE_BANK_ACCOUNT

Public Const PR_DF_VIZ_FACE = PR_DF_VIZ_FIELDS + PR_DFE_FACE
Public Const PR_DF_VIZ_SIGNATURE = PR_DF_VIZ_FIELDS + PR_DFE_SIGNATURE
Public Const PR_DF_VIZ_FINGERPRINT = PR_DF_VIZ_FIELDS + PR_DFE_FINGERPRINT
Public Const PR_DF_VIZ_IRIS = PR_DF_VIZ_FIELDS + PR_DFE_IRIS

Public Const PR_DF_VIZ_AUTHENTICITY = PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY
Public Const PR_DF_VIZ_AUTHENTICITY1 = PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY1
Public Const PR_DF_VIZ_AUTHENTICITY2 = PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY2
Public Const PR_DF_VIZ_AUTHENTICITY3 = PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY3
Public Const PR_DF_VIZ_AUTHENTICITY4 = PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY4
Public Const PR_DF_VIZ_AUTHENTICITY5 = PR_DF_VIZ_FIELDS + PR_DFE_AUTHENTICITY5

Public Const PR_DF_VIZ_AUTH_COMPOSITE = 2500
Public Const PR_DF_VIZ_AUTH_DOCAREA = 2551
Public Const PR_DF_VIZ_AUTH_ACCORDANCE = 2552
Public Const PR_DF_VIZ_AUTH_UVFIBRES = 2553

        'Barcode Reading (BC)
Public Const PR_DF_BC_FIELDS = 3000

Public Const PR_DF_BC1 = PR_DF_BC_FIELDS + PR_DFE_COMPOSITE1

        'Magnetic Stripe (MS)
Public Const PR_DF_MS_FIELDS = 4000

        ' RFID data
Public Const PR_DF_RFID_FIELDS = &H400000

Public Const PR_DF_RFID_MRZ = PR_DF_RFID_FIELDS Or &H10000
Public Const PR_DF_RFID_FACE = PR_DF_RFID_FIELDS Or &H20000
Public Const PR_DF_RFID_FINGERPRINT = PR_DF_RFID_FIELDS Or &H30000
Public Const PR_DF_RFID_IRIS = PR_DF_RFID_FIELDS Or &H40000
Public Const PR_DF_RFID_SIGNATURE = PR_DF_RFID_FIELDS Or &H50000

        'Final formatted data
Public Const PR_DF_FORMATTED = 10000

Public Const PR_DF_NAME = PR_DF_FORMATTED + PR_DFE_NAME
Public Const PR_DF_GIVENNAME = PR_DF_FORMATTED + PR_DFE_GIVENNAME
Public Const PR_DF_SURNAME = PR_DF_FORMATTED + PR_DFE_SURNAME
Public Const PR_DF_SURNAME2 = PR_DF_FORMATTED + PR_DFE_SURNAME2
Public Const PR_DF_MIDDLENAME = PR_DF_FORMATTED + PR_DFE_MIDDLENAME
Public Const PR_DF_MAIDEN_NAME = PR_DF_FORMATTED + PR_DFE_MAIDEN_NAME
Public Const PR_DF_MAIDEN_GIVENNAME = PR_DF_FORMATTED + PR_DFE_MAIDEN_GIVENNAME
Public Const PR_DF_MAIDEN_SURNAME = PR_DF_FORMATTED + PR_DFE_MAIDEN_SURNAME

Public Const PR_DF_BIRTH_DATE = PR_DF_FORMATTED + PR_DFE_BIRTH_DATE
Public Const PR_DF_BIRTH_PLACE = PR_DF_FORMATTED + PR_DFE_BIRTH_PLACE
Public Const PR_DF_BIRTH_COUNTRY = PR_DF_FORMATTED + PR_DFE_BIRTH_COUNTRY
Public Const PR_DF_MOTHER_NAME = PR_DF_FORMATTED + PR_DFE_MOTHER_NAME
Public Const PR_DF_MOTHER_GIVENNAME = PR_DF_FORMATTED + PR_DFE_MOTHER_GIVENNAME
Public Const PR_DF_MOTHER_SURNAME = PR_DF_FORMATTED + PR_DFE_MOTHER_SURNAME

Public Const PR_DF_NATIONALITY = PR_DF_FORMATTED + PR_DFE_NATIONALITY
Public Const PR_DF_SEX = PR_DF_FORMATTED + PR_DFE_SEX
Public Const PR_DF_BIRTH_PROVINCE = PR_DF_FORMATTED + PR_DFE_BIRTH_PROVINCE
Public Const PR_DF_PARENTS_NAME = PR_DF_FORMATTED + PR_DFE_PARENTS_NAME

Public Const PR_DF_DOCUMENT_NUMBER = PR_DF_FORMATTED + PR_DFE_DOCUMENT_NUMBER
Public Const PR_DF_TYPE = PR_DF_FORMATTED + PR_DFE_TYPE
Public Const PR_DF_ISSUE_COUNTRY = PR_DF_FORMATTED + PR_DFE_ISSUE_COUNTRY
Public Const PR_DF_ISSUE_PLACE = PR_DF_FORMATTED + PR_DFE_ISSUE_PLACE
Public Const PR_DF_ISSUE_STATE = PR_DF_FORMATTED + PR_DFE_ISSUE_STATE
Public Const PR_DF_ISSUE_DATE = PR_DF_FORMATTED + PR_DFE_ISSUE_DATE
Public Const PR_DF_EXPIRY_DATE = PR_DF_FORMATTED + PR_DFE_EXPIRY_DATE
Public Const PR_DF_ISSUE_ORG = PR_DF_FORMATTED + PR_DFE_ISSUE_ORG

Public Const PR_DF_PERSONAL_NUMBER = PR_DF_FORMATTED + PR_DFE_PERSONAL_NUMBER
Public Const PR_DF_HEALTH_INS_NUMBER = PR_DF_FORMATTED + PR_DFE_HEALTH_INS_NUMBER

Public Const PR_DF_DOCTYPE = PR_DF_FORMATTED + PR_DFE_DOCTYPE

Public Const PR_DF_PERSONAL_DATA = PR_DF_FORMATTED + PR_DFE_PERSONAL_DATA1
Public Const PR_DF_PERSONAL_DATA2 = PR_DF_FORMATTED + PR_DFE_PERSONAL_DATA2

Public Const PR_DF_ADDR_ZIP = PR_DF_FORMATTED + PR_DFE_ADDR_ZIP
Public Const PR_DF_ADDR_CITY = PR_DF_FORMATTED + PR_DFE_ADDR_CITY
Public Const PR_DF_ADDR_STREET = PR_DF_FORMATTED + PR_DFE_ADDR_STREET
Public Const PR_DF_ADDR_HOUSE = PR_DF_FORMATTED + PR_DFE_ADDR_HOUSE
Public Const PR_DF_ADDR_FLAT = PR_DF_FORMATTED + PR_DFE_ADDR_FLAT
Public Const PR_DF_ADDR_DATE = PR_DF_FORMATTED + PR_DFE_ADDR_DATE
Public Const PR_DF_ADDR_PROVINCE = PR_DF_FORMATTED + PR_DFE_ADDR_PROVINCE

Public Const PR_DF_TEMPADDR_ZIP = PR_DF_FORMATTED + PR_DFE_TEMPADDR_ZIP
Public Const PR_DF_TEMPADDR_CITY = PR_DF_FORMATTED + PR_DFE_TEMPADDR_CITY
Public Const PR_DF_TEMPADDR_STREET = PR_DF_FORMATTED + PR_DFE_TEMPADDR_STREET
Public Const PR_DF_TEMPADDR_HOUSE = PR_DF_FORMATTED + PR_DFE_TEMPADDR_HOUSE
Public Const PR_DF_TEMPADDR_FLAT = PR_DF_FORMATTED + PR_DFE_TEMPADDR_FLAT
Public Const PR_DF_TEMPADDR_DATE = PR_DF_FORMATTED + PR_DFE_TEMPADDR_DATE
Public Const PR_DF_TEMPADDR_DATEEND = PR_DF_FORMATTED + PR_DFE_TEMPADDR_DATEEND
Public Const PR_DF_TEMPADDR_PROVINCE = PR_DF_FORMATTED + PR_DFE_TEMPADDR_PROVINCE

Public Const PR_DF_REFERENCE = PR_DF_FORMATTED + PR_DFE_REFERENCE
Public Const PR_DF_AMOUNT = PR_DF_FORMATTED + PR_DFE_AMOUNT
Public Const PR_DF_BANK_ACCOUNT = PR_DF_FORMATTED + PR_DFE_BANK_ACCOUNT
Public Const PR_DF_POSTAL_REFERENCE = PR_DF_FORMATTED + PR_DFE_POSTAL_REFERENCE
Public Const PR_DF_TRANSACTION_CODE = PR_DF_FORMATTED + PR_DFE_TRANSACTION_CODE
Public Const PR_DF_SUPPLIER = PR_DF_FORMATTED + PR_DFE_SUPPLIER
Public Const PR_DF_OUTPUT_CODE = PR_DF_FORMATTED + PR_DFE_OUTPUT_CODE

Public Const PR_DF_FACE = PR_DF_FORMATTED + PR_DFE_FACE

Public Const PR_DF_HEIGHT = PR_DF_FORMATTED + PR_DFE_HEIGHT
Public Const PR_DF_WEIGHT = PR_DF_FORMATTED + PR_DFE_WEIGHT
Public Const PR_DF_EYECOLOR = PR_DF_FORMATTED + PR_DFE_EYECOLOR

Public Const PR_DF_AUTHENTICITY = PR_DF_FORMATTED + PR_DFE_AUTHENTICITY

' PR_PROP_TYPE
Public Const PR_PROP_TYPE_BASE = &H0
Public Const PR_PROP_TYPE_GENERAL = &HF00000
Public Const PR_PROP_TYPE_COMPOSITE = &HF10000

Public Const PR_PROP_TYPE_BARCODE_TYPE = PR_PROP_TYPE_BASE Or &H1
Public Const PR_PROP_TYPE_RFID_FILES = PR_PROP_TYPE_BASE Or &H2
Public Const PR_PROP_TYPE_CONFIDENCE = PR_PROP_TYPE_BASE Or &H3

Public Const PR_PROP_TYPE_FACIAL_RECORD_HEADER = PR_PROP_TYPE_COMPOSITE Or &H1
Public Const PR_PROP_TYPE_FACIAL_INFORMATION = PR_PROP_TYPE_COMPOSITE Or &H2
Public Const PR_PROP_TYPE_FEATURE_POINTS = PR_PROP_TYPE_COMPOSITE Or &H3
Public Const PR_PROP_TYPE_IMAGE_INFORMATION = PR_PROP_TYPE_COMPOSITE Or &H4

