Attribute VB_Name = "prtypes"
'-------------------------------------------------------------------------------
' PR TYPES 2004-2021 (c) Adaptive Recognition
' 2021.06.03 v2.1.10
'-------------------------------------------------------------------------------

'Device connection modes
' PR_USAGEMODE
Public Const PR_UMODE_DISCONNECT = 0
Public Const PR_UMODE_NORMAL_USE = 1
Public Const PR_UMODE_FULL_CONTROL = 2

'Device freerun light controlling modes
' PR_FREERUNMODE
Public Const PR_FRMODE_NULL = &H0
Public Const PR_FRMODE_PREVIEWLIGHT = &H1
Public Const PR_FRMODE_UVLEDWARMING = &H2
Public Const PR_FRMODE_TESTDOCUMENT = &H4

'Device document detection methods
' PR_TESTDOCMODE
Public Const PR_TDM_COMBINED = 0
Public Const PR_TDM_COMBINEDMOVEABLE = 1
Public Const PR_TDM_FORCEDSOFTWARE = 2
Public Const PR_TDM_DELAYEDHARDWARE = 3

'Object windows
' PR_WINDOW_ID
Public Const PR_OW_MASK = &HFF000000
Public Const PR_OW_DEFAULT = &H0
Public Const PR_OW_1ST = &H1000000
Public Const PR_OW_2ND = &H2000000

'Options for page light setup
' PR_PAGELIGHT_PROP
Public Const PR_CAPTURE_CONTINUOUS = &H10000000
Public Const PR_APPEND_PAGELIGHTS = &H20000000

'Illuminations
' PR_LIGHT
Public Const PR_LIGHT_OFF = 0
Public Const PR_LIGHT_WHITE = 1
Public Const PR_LIGHT_INFRA = 2
Public Const PR_LIGHT_UV = 3
Public Const PR_LIGHT_COAXIAL = 4
Public Const PR_LIGHT_KINEGRAM = 5
Public Const PR_LIGHT_PHOTO = 6
Public Const PR_LIGHT_BLUE = 16
Public Const PR_LIGHT_RED = 17
Public Const PR_LIGHT_CLEANUV = 19
Public Const PR_LIGHT_CLEANOVD = 21
Public Const PR_LIGHT_EDGE = 25

'Document detection modes
' PR_TESTDOC
Public Const PR_TD_OUT = 0
Public Const PR_TD_MOVE = 1
Public Const PR_TD_NOMOVE = 2
Public Const PR_TD_IN = 4

'Barcode types
' PR_BCTYPE {
Public Const PR_BCTYPE_EAN8 = 1
Public Const PR_BCTYPE_EAN13 = 2
Public Const PR_BCTYPE_CODE39 = 3
Public Const PR_BCTYPE_CODE128 = 4
Public Const PR_BCTYPE_PDF417 = 5
Public Const PR_BCTYPE_INTER25 = 6
Public Const PR_BCTYPE_DATAMATRIX = 7
Public Const PR_BCTYPE_QR = 8
Public Const PR_BCTYPE_AZTEC = 9
Public Const PR_BCTYPE_UPU = 10

'Image types
' PR_IMAGE_TYPE
Public Const PR_IT_ORIGINAL = 0
Public Const PR_IT_DOCUMENT = 1
Public Const PR_IT_PREVIEW = 2
Public Const PR_IT_FINGER = 3

'Event types
' PR_EVENT
Public Const PR_ET_LED = 1
Public Const PR_ET_CAPTURE = 2
Public Const PR_ET_RFID = 8

Public Const PR_EV_UVLEDWARMING = 1

Public Const PR_EV_PAGECAPTURED = 101
Public Const PR_EV_IMAGECAPTURED = 102
Public Const PR_EV_CAPTURESTARTED = 103
Public Const PR_EV_NOIMAGEINFO = 104
Public Const PR_EV_DOCFRAMEFOUND = 105
Public Const PR_EV_FGCAP = 106
Public Const PR_EV_PREVIEWCAPTURED = 107

Public Const PR_EV_RFAUTH_BEGIN = 301
Public Const PR_EV_RFAUTH_WAIT4INPUT = 302
Public Const PR_EV_RFAUTH_DONE = 303
Public Const PR_EV_RFFILE_BEGIN = 304
Public Const PR_EV_RFFILE_DONE = 305
Public Const PR_EV_RFFILE_CHECKED = 306

'Document file formats
' PR_DOCFILEFORMATS
Public Const PR_DFF_XML = 1
Public Const PR_DFF_ZIPPED = 2
Public Const PR_DFF_AUTH = 3
Public Const PR_DFF_ENCZIP = 4
Public Const PR_DFF_BSIAUTHLOG = 5

'Rfid file identifiers
' PR_RFID_FILES
Public Const PR_RFID_EF_COM = 0
Public Const PR_RFID_EF_DG1 = 1
Public Const PR_RFID_EF_DG2 = 2
Public Const PR_RFID_EF_DG3 = 3
Public Const PR_RFID_EF_DG4 = 4
Public Const PR_RFID_EF_DG5 = 5
Public Const PR_RFID_EF_DG6 = 6
Public Const PR_RFID_EF_DG7 = 7
Public Const PR_RFID_EF_DG8 = 8
Public Const PR_RFID_EF_DG9 = 9
Public Const PR_RFID_EF_DG10 = 10
Public Const PR_RFID_EF_DG11 = 11
Public Const PR_RFID_EF_DG12 = 12
Public Const PR_RFID_EF_DG13 = 13
Public Const PR_RFID_EF_DG14 = 14
Public Const PR_RFID_EF_DG15 = 15
Public Const PR_RFID_EF_DG16 = 16
Public Const PR_RFID_EF_DG17 = 17
Public Const PR_RFID_EF_DG18 = 18
Public Const PR_RFID_EF_DG19 = 19
Public Const PR_RFID_EF_DG20 = 20
Public Const PR_RFID_EF_DG21 = 21
Public Const PR_RFID_EF_DG22 = 22
Public Const PR_RFID_EF_CARD_ACCESS = 28
Public Const PR_RFID_EF_CARD_SECURITY = 29
Public Const PR_RFID_EF_CVCA = 30
Public Const PR_RFID_EF_SOD = 31
Public Const PR_RFID_CF_DS = 32
Public Const PR_RFID_CF_CSCA = 33
Public Const PR_RFID_EF_ALL = -1
Public Const PR_RFID_EF_SEL = -2

Public Const PR_RFID_GENERAL_DATA = 1000
Public Const PR_RFID_PERSONAL_DETAILS = 1001
Public Const PR_RFID_ISSUER_DETAILS = 1002
Public Const PR_RFID_PORTRAIT = 1003
Public Const PR_RFID_SIGNATURE = 1004
Public Const PR_RFID_FACE = 1005
Public Const PR_RFID_FINGER = 1006
Public Const PR_RFID_IRIS = 1007
Public Const PR_RFID_OTHER_BIOMETRIC_DATA = 1008
Public Const PR_RFID_DOMESTIC_DATA = 1009
Public Const PR_RFID_AA_DATA = 1010
Public Const PR_RFID_ANY_FACE = 1011
Public Const PR_RFID_TOCFILE = 1012
Public Const PR_RFID_EAP_DATA = 1013

' Memory addressing options for rfid storage cards
' PR_RFID_MEMOPTS
Public Const PR_RFID_MEMORY_ADDRESS = &H40000000
Public Const PR_RFID_BLOCK_ADDRESS = &H20000000
Public Const PR_RFID_SECTOR_ADDRESS = &O60000000

'Authentication codes
' PR_AUTH_PROC
Public Const PR_NO_AUTH_PROCESS = 0
Public Const PR_PASSIVE_AUTH = 1
Public Const PR_TERMINAL_AUTH = 2
Public Const PR_PACE = 3
Public Const PR_BAC = 4
Public Const PR_CHIP_AUTH = 5
Public Const PR_ACTIVE_AUTH = 6
Public Const PR_SELECT_APPLICATION = 7
Public Const PR_BAP = 8
Public Const PR_BLOCK_AUTH = 9
Public Const PR_INIT_TERMINAL_AUTH = 10
Public Const PR_COMPLETE_TERMINAL_AUTH = 11
Public Const PR_STORAGE_CARD_AUTH = 12

'Application types
' PR_APP_TYPE
Public Const PR_APP_NONE = 0
Public Const PR_APP_EPASSPORT = 1
Public Const PR_APP_EID = 2
Public Const PR_APP_ESIGN = 3
Public Const PR_APP_ISODL = 4
Public Const PR_APP_NFC = 5
Public Const PR_APP_EDL = 6

'Password codes for Password Authenticated Connection Establishment (PACE)
' PR_PACE_PASSWORD
Public Const PR_PACE_PW_MRZ = 1
Public Const PR_PACE_PW_CAN = 2
Public Const PR_PACE_PW_PIN = 3
Public Const PR_PACE_PW_PUK = 4

'Certificate selection flag
' PR_CERTIFICATE_SELECTION
Public Const PR_SEL_CERT_EXPIRED = &H100
Public Const PR_SEL_CERT_REVOKED = &H200

'Power state codes
' PR_POWER_STATE
Public Const PR_PWR_MASK = &HF

Public Const PR_PWR_UNKNOWN = &H0
Public Const PR_PWR_OFF = &H1
Public Const PR_PWR_ON = &H2
Public Const PR_PWR_DATA = &H3

Public Const PR_BATTERY_MASK = &HF0

Public Const PR_BATTERY_UNAVAILABLE = &H0
Public Const PR_BATTERY_AVAILABLE = &H10
Public Const PR_BATTERY_UNKNOWN = &H20

'Status led color codes
' PR_STATUS_LED_COLOR
Public Const PR_SLC_OFF = &H0
Public Const PR_SLC_OG = &H2
Public Const PR_SLC_ORG = &H3
Public Const PR_SLC_SYSTEM = &H10
Public Const PR_SLC_GREEN = &H81
Public Const PR_SLC_RED = &H82
Public Const PR_SLC_ORANGE = &H83
Public Const PR_SLC_BLUE = &H84
Public Const PR_SLC_AUTO = &HAC
Public Const PR_SLC_ANY = &HFF

'Id of the buzzer
' PR_BUZZER
Public Const PR_SLC_BUZZER = &HC0

'Button state codes
' PR_KEY_STATE
Public Const PR_KEY_UNKNOWN = 0
Public Const PR_KEY_PRESSED = 1
Public Const PR_KEY_RELEASED = 2
Public Const PR_KEY_NOKEY = 3

'Button codes
' PR_KEY_CODE
Public Const PR_KEY_POWER = &H10101
Public Const PR_KEY_START = &H10110

'Hardware part types
' PR_HWTYPE
Public Const PR_HW_IO = 0
Public Const PR_HW_SCANNER = 1
Public Const PR_HW_RFIDREADER = 2
Public Const PR_HW_CONTACTREADER = 3
Public Const PR_HW_MAGNETICREADER = 4

'Variant IDs used
' PR_VAR_ID

Public Const PRV_ROOT = 0

Public Const PRV_PAGELIST = PRV_ROOT Or 1
Public Const PRV_TASKLIST = PRV_ROOT Or 2
Public Const PRV_PERSONINFO = PRV_ROOT Or 3
Public Const PRV_DOCINFO = PRV_ROOT Or 4

Public Const PRV_DOCUMENT = &HD0000000
Public Const PRV_FIELDLIST = PRV_DOCUMENT Or 1
Public Const PRV_FIELD = PRV_DOCUMENT Or 2
Public Const PRV_FIELDVALUE = PRV_DOCUMENT Or 3
Public Const PRV_CHECKSUM = PRV_DOCUMENT Or 4
Public Const PRV_CONFIDENCE = PRV_DOCUMENT Or 5
Public Const PRV_WINDOWFRAME = PRV_DOCUMENT Or 6
Public Const PRV_WINDOWFULLFRAME = PRV_DOCUMENT Or 7
Public Const PRV_ACCORDANCE = PRV_DOCUMENT Or 8
Public Const PRV_FMTVALUE = PRV_DOCUMENT Or 9
Public Const PRV_STDVALUE = PRV_DOCUMENT Or 10
Public Const PRV_CORRECTION = PRV_DOCUMENT Or 11
Public Const PRV_FIELDCOMPARES = PRV_DOCUMENT Or 12
Public Const PRV_CHKDETAILS = PRV_DOCUMENT Or 13
Public Const PRV_AMID = PRV_DOCUMENT Or 14

Public Const PRV_IMAGE = &HD0100000
Public Const PRV_IMAGELIST = PRV_IMAGE Or 1
Public Const PRV_IMAGEFRAME = PRV_IMAGE Or 2
Public Const PRV_SAMPLE = PRV_IMAGE Or 3

Public Const PRV_DEVICE_INFO = &HD0200000
Public Const PRV_DEVICE_ID = PRV_DEVICE_INFO Or 1
Public Const PRV_LIGHT = PRV_DEVICE_INFO Or 2
Public Const PRV_CAPTIME = PRV_DEVICE_INFO Or 3
Public Const PRV_PAGE = PRV_DEVICE_INFO Or 4
Public Const PRV_TRAFO = PRV_DEVICE_INFO Or 5
Public Const PRV_CAMERA = PRV_DEVICE_INFO Or 6
Public Const PRV_MODE = PRV_DEVICE_INFO Or 8
Public Const PRV_HWTYPE = PRV_DEVICE_INFO Or 9
Public Const PRV_STATLEDLIST = PRV_DEVICE_INFO Or 10
Public Const PRV_KEYBOARD = PRV_DEVICE_INFO Or 11
Public Const PRV_POWER = PRV_DEVICE_INFO Or 12
Public Const PRV_VERSION = PRV_DEVICE_INFO Or 13
Public Const PRV_WINDOWLIST = PRV_DEVICE_INFO Or 14
Public Const PRV_CAPABILITY = PRV_DEVICE_INFO Or 15
Public Const PRV_DISPLAY = PRV_DEVICE_INFO Or 16

Public Const PRV_BARCODE = &HD0300000
Public Const PRV_BARCODEVALUE = PRV_BARCODE Or 1
Public Const PRV_BARCODELIST = PRV_BARCODE Or 2

Public Const PRV_OCR = &HD0400000
Public Const PRV_OCRROWLIST = PRV_OCR Or 1
Public Const PRV_OCRROW = PRV_OCR Or 2
Public Const PRV_OCRCHAR = PRV_OCR Or 3

Public Const PRV_OQCA = PRV_OCR Or &H80000
Public Const PRV_OQC_ROTATION = PRV_OQCA Or 1
Public Const PRV_OQC_HEIGHT = PRV_OQCA Or 2
Public Const PRV_OQC_WIDTH = PRV_OQCA Or 3
Public Const PRV_OQC_HANGOUT = PRV_OQCA Or 4
Public Const PRV_OQC_DISTANCE = PRV_OQCA Or 5
Public Const PRV_OQC_CONTRAST = PRV_OQCA Or 6
Public Const PRV_OQC_SHAPE = PRV_OQCA Or 7

Public Const PRV_ENGINE = PRV_OCR Or &HA0000
Public Const PRV_ENG_LIC = PRV_ENGINE Or 1
Public Const PRV_ENG_LICDATE = PRV_ENGINE Or 2
Public Const PRV_ENG_LICTYPE = PRV_ENGINE Or 3

Public Const PRV_RFID = &HD0500000
Public Const PRV_RFIDDIR = PRV_RFID Or 1
Public Const PRV_RFIDFILELIST = PRV_RFID Or 2
Public Const PRV_RFIDFILE = PRV_RFID Or 3
Public Const PRV_RFIDFILEDATA = PRV_RFID Or 4
Public Const PRV_CERTID_LIST = PRV_RFID Or 5
Public Const PRV_DGLIST = PRV_RFID Or 6
Public Const PRV_AUTHLIST = PRV_RFID Or 7

Public Const PRV_CARD = &HD0600000
Public Const PRV_CARDTYPE = PRV_CARD Or 1
Public Const PRV_CARDATR = PRV_CARD Or 2
Public Const PRV_CARDPOS = PRV_CARD Or 3
Public Const PRV_MEMORY_SIZE = PRV_CARD Or 4
Public Const PRV_MEMORY_BLOCK = PRV_CARD Or 5
Public Const PRV_CARDCAP = PRV_CARD Or 6
Public Const PRV_CHIPTYPE = PRV_CARD Or 7

Public Const PRV_COMMON = &HD0700000
Public Const PRV_PROCTIME = PRV_COMMON Or 1
Public Const PRV_PROCPERIOD = PRV_COMMON Or 2
Public Const PRV_WARNLIST = PRV_COMMON Or 3
Public Const PRV_TASK = PRV_COMMON Or 4
Public Const PRV_ODATA = PRV_COMMON Or 5

Public Const PRV_FINGER = &HD0800000
Public Const PRV_FINGER_TYPE = PRV_FINGER Or 1
Public Const PRV_NIST_QUALITY = PRV_FINGER Or 2
Public Const PRV_FINGER_DRYWET = PRV_FINGER Or 3
Public Const PRV_FINGER_FRACTION = PRV_FINGER Or 4

'Variant IDs used in special OCR operations.
' PR_VAR_ID_OCR_PARAMS

Public Const PRV_OCRPARAMS = PRV_OCR Or &H90000

Public Const PRV_CHARHEIGHT = PRV_OCRPARAMS Or 1
Public Const PRV_SPACEWIDTH = PRV_OCRPARAMS Or 2
Public Const PRV_JUSTIFICATION = PRV_OCRPARAMS Or 3
Public Const PRV_SPACETYPE = PRV_OCRPARAMS Or 4
Public Const PRV_FONTTYPE = PRV_OCRPARAMS Or 5

'OCR quality check flags.
' PR_OCR_QUALITY_ALERT
Public Const PR_OQA_CHARPOSITION = 1
Public Const PR_OQA_CHARDISTANCE = 2
Public Const PR_OQA_CHARSIZE = 4
Public Const PR_OQA_CHARROTATION = 8
Public Const PR_OQA_CONTRAST = &H10
Public Const PR_OQA_SPARE = &H20
Public Const PR_OQA_ERZ = &H40
Public Const PR_OQA_ROWPOSITION = &H100
Public Const PR_OQA_ROWDISTANCE = &H200
Public Const PR_OQA_ROWSIZE = &H400
Public Const PR_OQA_ROWROTATION = &H800
Public Const PR_OQA_SHAPE = &H1000

'Variant ids for warnings of the Passive Authentication.
' PR_VAR_ID_PA_WARNINGS

Public Const PRV_PA_WARNLIST = &HD0590000

Public Const PRV_PA_WARN_UNKNOWN_DG = PRV_PA_WARNLIST Or 1
Public Const PRV_PA_WARN_DG_MISSING = PRV_PA_WARNLIST Or 2
Public Const PRV_PA_WARN_DG_HASH_MISSING = PRV_PA_WARNLIST Or 3
Public Const PRV_PA_WARN_COM_FORMAT = PRV_PA_WARNLIST Or 4
Public Const PRV_PA_WARN_HASH_CHECK = PRV_PA_WARNLIST Or 5
Public Const PRV_PA_WARN_COM_MISSING = PRV_PA_WARNLIST Or 6

Public Const PRV_PA_WARN_DS_NOTFOUND = PRV_PA_WARNLIST Or 7
Public Const PRV_PA_WARN_DS_DATE_INVALID = PRV_PA_WARNLIST Or 8
Public Const PRV_PA_WARN_DS_DATE_RANGE = PRV_PA_WARNLIST Or 9
Public Const PRV_PA_WARN_DS_REVOKED = PRV_PA_WARNLIST Or 10
Public Const PRV_PA_WARN_DS_EXPIRED = PRV_PA_WARNLIST Or 11
Public Const PRV_PA_WARN_DS_WRONG_SIGNATURE = PRV_PA_WARNLIST Or 12

Public Const PRV_PA_WARN_AUTHKEYID_FORMAT = PRV_PA_WARNLIST Or 13
Public Const PRV_PA_WARN_AUTHKEYID_MISSING = PRV_PA_WARNLIST Or 14

Public Const PRV_PA_WARN_CS_NOTFOUND = PRV_PA_WARNLIST Or 15
Public Const PRV_PA_WARN_CS_EXPIRED = PRV_PA_WARNLIST Or 16
Public Const PRV_PA_WARN_CS_REVOKED = PRV_PA_WARNLIST Or 17
Public Const PRV_PA_WARN_CS_WRONG_SIGNATURE = PRV_PA_WARNLIST Or 18

Public Const PRV_PA_WARN_SOD_MISSING = PRV_PA_WARNLIST Or 19
Public Const PRV_PA_WARN_SOD_FORMAT = PRV_PA_WARNLIST Or 20
Public Const PRV_PA_WARN_SOD_SIGNATURE_MISSING = PRV_PA_WARNLIST Or 21
Public Const PRV_PA_WARN_SOD_HASH_CHECK = PRV_PA_WARNLIST Or 22
Public Const PRV_PA_WARN_SOD_HASH_NOTFOUND = PRV_PA_WARNLIST Or 23
Public Const PRV_PA_WARN_SOD_WRONG_SIGNATURE = PRV_PA_WARNLIST Or 24
Public Const PRV_PA_WARN_SOD_SIGNEDDATA_MISSING = PRV_PA_WARNLIST Or 25

Public Const PRV_PA_WARN_CHAIN_DIFFERENT_ISSUER = PRV_PA_WARNLIST Or 26

'Detailed checking states.
' PR_VAR_CHECKINGS

Public Const PRV_CHK_MISSING = &HD0080003

Public Const PRV_CHK_SELFCHK_OK = &HD0080010
Public Const PRV_CHK_SELFCHK_INVALID = &HD0080012
Public Const PRV_CHK_SELFCHK_FAILED = &HD0080013

Public Const PRV_CHK_FORMAT_OK = &HD0080020
Public Const PRV_CHK_FORMAT_INVALID = &HD0080023

Public Const PRV_CHK_DATE_OK = &HD0080030
Public Const PRV_CHK_DATE_INVALID = &HD0080032
Public Const PRV_CHK_DATE_EXPIRED = &HD0080033

Public Const PRV_CHK_REVOKED = &HD0080043

'Finger storage IDs.
' PR_FINGER_POSITION
Public Const PR_FG_UNKNOWN = 0
Public Const PR_FG_RIGHT_THUMB = 1
Public Const PR_FG_RIGHT_INDEX = 2
Public Const PR_FG_RIGHT_MIDDLE = 3
Public Const PR_FG_RIGHT_RING = 4
Public Const PR_FG_RIGHT_LITTLE = 5
Public Const PR_FG_LEFT_THUMB = 6
Public Const PR_FG_LEFT_INDEX = 7
Public Const PR_FG_LEFT_MIDDLE = 8
Public Const PR_FG_LEFT_RING = 9
Public Const PR_FG_LEFT_LITTLE = 10

Public Const PR_FG_PLAIN_RIGHT_THUMB = 11
Public Const PR_FG_PLAIN_LEFT_THUMB = 12
Public Const PR_FG_PLAIN_RIGHT_4FINGERS = 13
Public Const PR_FG_PLAIN_LEFT_4FINGERS = 14
Public Const PR_FG_PLAIN_THUMBS = 15

Public Const PR_FG_BOTH_INDEXES = 46

'The capturing mode of the finger capture process.
' PR_FINGER_IMPRESSION_TYPE
Public Const PR_FG_SCAN_LIVE = 0
Public Const PR_FG_SCAN_ROLLED = 1
Public Const PR_FG_SCAN_ACCUMULATED = &H1000

'Elements of the self test.
' PR_SELFTEST_ELEMENTS
Public Const PRV_SELFTESTLIST = &H57000000
Public Const PRV_ST_OVERALL_RESULT = PRV_SELFTESTLIST + 1
Public Const PRV_ST_DEVICE_COMM = PRV_SELFTESTLIST + 2
Public Const PRV_ST_RFID_COMM = PRV_SELFTESTLIST + 3
Public Const PRV_ST_CALIBRATED = PRV_SELFTESTLIST + 4
Public Const PRV_ST_SENSOR_COMM = PRV_SELFTESTLIST + 5
Public Const PRV_ST_SENSOR_BUS = PRV_SELFTESTLIST + 6
Public Const PRV_ST_LIGHT_SWITCH = PRV_SELFTESTLIST + 7
Public Const PRV_ST_LIGHT_BLOWOUT = PRV_SELFTESTLIST + 8
Public Const PRV_ST_NNC = PRV_SELFTESTLIST + 9
Public Const PRV_ST_THERMOMETER = PRV_SELFTESTLIST + 10

'Result of the self test.
' PR_SELFTEST_RESULT
Public Const PR_ST_RESULT_OK = 0
Public Const PR_ST_RESULT_SKIPPED = 1
Public Const PR_ST_RESULT_UNKNOWN = 2
Public Const PR_ST_RESULT_FAILED = 3

'PR engine license types.
' PR_LICENSE
Public Const PR_LICENSE_MRZOCR_BARCODEREADING = &HF4
Public Const PR_LICENSE_MRZOCR_BARCODEREADINGL = &H74
Public Const PR_LICENSE_MRZOCR_BARCODEREADINGF = &H84
Public Const PR_LICENSE_VIZOCR_COUNTRY = &H10
Public Const PR_LICENSE_VIZOCR_REGION = &H11
Public Const PR_LICENSE_VIZOCR_WORLD = &H12
Public Const PR_LICENSE_VIZOCRAUTH_COUNTRY = &H13
Public Const PR_LICENSE_VIZOCRAUTH_REGION = &H14
Public Const PR_LICENSE_VIZOCRAUTH_WORLD = &H15
Public Const PR_LICENSE_PRSOFTWARE = &HA1
Public Const PR_LICENSE_PRAUTOFILL = &HA2
Public Const PR_LICENSE_ECARD = &HEC
Public Const PR_LICENSE_HOTEL_INTERFACE = &HFA

